<?
//Created 01/04/2017
require_once "../internal/inc_connect.php";
require_once "../inc_functions.php";
require_once "inc_common_functions.php";
require_once "krumo/class.krumo.php";
require_once "../constants.php";

require_once "../classes/Setting.php";

debug_init();
db_init();

$action_log = array();
$error = "";
$update_mode = "false";

function add_error($msg)
{
  global $error, $error_template;
  $error .= insert($error_template, $msg);
}

$switchIsRequired = new \Patreon\SettingSwitch("is_required", "", null, "1",
  array(
  "1" => "Required",
  "0" => "Optional"),"warning");
$switchSide = new \Patreon\SettingSwitch("side", "", null, "1",
  array(
  "0" => "Server",
  "1" => "Both",
  "2" => "Client"), "warning");
$switchDefaultSelected = new \Patreon\SettingSwitch("defaultSelected", "", null, "1",
  array(
  "1" => "Selected",
  "0" => "Deselected"), "warning");

$query = "SELECT DISTINCT(mod_id), mod_name, version_to FROM files WHERE version_to != 'removed' AND update_id IS NOT NULL AND update_id != ''";
$result = mysqli_query($con, $query);
$unique_mods = array();
if ($result && mysqli_num_rows($result) > 0)
{
  while ($row = mysqli_fetch_assoc($result))
  {
    $unique_mods[$row['mod_id']] = array("id" => $row['mod_id'], "name" => $row['mod_name'], "version" => $row['version_to']);
  }
}

$unique_mods = array_order_by($unique_mods, "mod_name");

if (isset($_GET['id']))
{
  $update_mode = "true";

  $file_id = $_GET['id'];
  $query = "SELECT * FROM files WHERE id = '$file_id'";
  $result = mysqli_query($con, $query);
  if ($result)
  {
    $row = mysqli_fetch_assoc($result);
    $mod_id = $row['mod_id'];
    $mod_name = $row['mod_name'];
    $system_file_name = $row['system_file_name'];
    $filename = $row['filename'];
    $path = $row['path'];
    if ($path[strlen($path) - 1] !== "/")
      $path .= "/";
    $version_from = $row['version_to'];
    $version_to = "";
    //$is_required = $row['is_required'];
    $switchIsRequired->value = $row['is_required'];
    //$pack_side = $row['pack_side'];
    $switchSide->value = $row['pack_side'];
    //$default_selected = $row['default_selected'];
    $switchDefaultSelected->value = $row['default_selected'];
    $sub_files = array();
    $description = $row['description'];
    $query = "SELECT * FROM files WHERE parent_identifier = '".$row['update_id']."' AND version_to != 'removed'";
    $result = mysqli_query($con, $query);
    if ($result && mysqli_num_rows($result) > 0)
    {
      while ($sub_row = mysqli_fetch_assoc($result))
      {
        array_push($sub_files, $sub_row);
      }
    }
    if (stristr($row['other_dependencies'], ";") !== false)
      $sub_dependencies = explode(";", $row['other_dependencies']);
    else if ($row['other_dependencies'] != false)
      $sub_dependencies = array($row['other_dependencies']);
    else
      $sub_dependencies = array();
  }
}
else if (isset($_POST['mod_id']))
{
//  krumo($_POST);
//  die();
  $update_mode = ((isset($_POST['update_mode']) && $_POST['update_mode'] == "true") ? true : false);
  $update_id = uniqid();
  $mod_id = $_POST['mod_id'];
  $mod_name = $_POST['mod_name'];
  $version_from = $_POST['version_from'];
  $version_to = $_POST['version_to'];
  $is_required = $switchIsRequired->GetValueFromPostReadOnly();
  $pack_side = $switchSide->GetValueFromPostReadOnly();
  $default_selected = $switchDefaultSelected->GetValueFromPostReadOnly();
  //$is_required = $_POST['is_required'];
  //$pack_side = $_POST['pack_side'];
  //$default_selected = (isset($_POST['default_selected']) ? true : false);
  $existing_dependencies = (isset($_POST['existing_dependencies']) && count($_POST['existing_dependencies']) > 0) ? implode(";", $_POST['existing_dependencies']) : "";
  $update_reason = $_POST['update_reason'];
  $description = $_POST['description'];

  if (!isset($mod_name) || $mod_name == "")
    add_error("Specify 'Mod Name'");
  if (!isset($version_from) || $version_from == "")
    add_error("No 'Version From'");
  if (!isset($version_to) || $version_to == "")
    add_error("Specify 'Version To'");
  if ($_FILES['mod_files']['name'][0] == "" && $_POST['update_mode'] == "false")
    add_error("Select at least one file!");

  if ($error == "")
  {
    $non_file_counter = 0;
    $file_counter = 0;
    foreach ($_POST['entry_is_file'] as $index => $is_file)
    {
      $do_query = true;
      if ($is_file === "true")
      {
        array_push($action_log, "Entry " . $index . " is a file! (file index: $file_counter) (index: $index)");
        $tmp = $_FILES['mod_files']['tmp_name'][$file_counter];
        $filename = $_FILES['mod_files']['name'][$file_counter];
        $system_file_name = uniqid($_FILES['mod_files']['name'][$file_counter] . "-");
        $path = ltrim($_POST['mod_paths'][$index], "/\\");
        if ($path[strlen($path) - 1] !== "/")
          $path .= "/";
        $type = $_POST['file_types'][$index];
        $file_error = $_FILES['mod_files']['error'][$file_counter];
        $is_sub_file = $_POST['is_sub_file'][$index] == "true";
        $is_removed_file = $_POST['is_removed_file'][$index] == "true";

        if ($file_error == 0)
        {
          if (!file_exists("../files/"))
            mkdir("../files/");
          $mv_result = move_uploaded_file($tmp, "../files/" . $system_file_name);

          if (!$mv_result)
          {
            add_error("Failed to upload file '" . $filename . "': Server error");
          }
        }
        else
          add_error("Failed to upload file '" . $filename . "': " . fileCodeToMessage($file_error));
        $file_counter++;
      }
      else
      {
        array_push($action_log, "Entry " . $index . " is not a file! (non-file index: $non_file_counter) (index: $index)");
        $filename = $_POST['filename'][$non_file_counter];
        $system_file_name = $_POST['system_file_name'][$non_file_counter];
        $path = ltrim($_POST['mod_paths'][$index], "/\\");
        if ($path[strlen($path) - 1] !== "/")
          $path .= "/";
        $type = $_POST['file_types'][$index];
        $is_sub_file = $_POST['is_sub_file'][$index] == "true";
        $is_removed_file = $_POST['is_removed_file'][$index] == "true";
        $non_file_counter++;
      }
      $values = array(
        "mod_name" => mysqli_escape($con, $mod_name),
        "mod_id" => mysqli_escape($con, (($index === 0) ? $mod_id : $mod_id . "_" . $index)),
        "system_file_name" => mysqli_escape($con, $system_file_name),
        "filename" => mysqli_escape($con, $filename),
        "parent_identifier" => (($index === 0) ? "" : $update_id),
        "file_type" => $type,
        "path" => mysqli_escape($con, $path),
        "update_id" => (($index === 0) ? $update_id : ""),
        "update_time" => time(),
        "version_from" => mysqli_escape($con, $version_from),
        "version_to" => ($is_sub_file && $is_removed_file) ? "removed" : mysqli_escape($con, $version_to),
        "is_required" => $is_required,
        "pack_side" => $pack_side,
        "other_dependencies" => mysqli_escape($con, $existing_dependencies),
        "default_selected" => $default_selected,
        "update_reason" => mysqli_escape($con, $update_reason),
        "description" => mysqli_escape($con, $description)
      );

      if ($do_query)
      {
        $query = build_query("files", $values);
        array_push($action_log, "QUERY: " . $query);

        $q_result = mysqli_query($con, $query);

        if ($q_result)
        {
          if ($update_mode)
            header("location: .");
          $error = insert($success_template, "Update added");
        }
        else
        {
          $error = insert($error_template, "Failed to add update (SQL Error)");
          log_file(mysqli_error($con), "../sql.log");
        }
      }
    }
  }
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>ForeModpacker</title>
  <link rel='stylesheet' href='../assets/bootstrap.min.css' />
  <script src='../assets/bootstrap.min.js'></script>
  <script src='../assets/cookie_functions.min.js'></script>
  <link rel='stylesheet' href='../assets/styles.css' />
  <script src="../internal/functions.js"></script>
  <style>
    .root
    {
      margin: 30px;
    }

    .input-row
    {
      margin-bottom: 10px;
    }
  </style>
</head>
<body>
<div class="container" style="margin-top: 20px;">
  <div class="u-full-width">
    <h2>ADD OR UPDATE FILE</h2>
  </div>
  <div>
    <span style="font-size: 14pt; color: red;">Remember to add to mod whitelist if a mod such as ModControl is present!</span>
  </div>
  <div>
    <?=($error != "") ? $error : ""?>
  </div>
  <form action="add" method="post" enctype="multipart/form-data">
    <input type="hidden" name="update_mode" value="<?=$update_mode?>" />
    <div class="row space" style="margin-top: 20px;">
      <div class="col-md-4"><input class="form-control" type="text" name="mod_name" placeholder="Mod Name" required value="<?=(isset($mod_name)) ? $mod_name : ""?>" /></div>
      <div class="col-md-5">Mod Name</div>
    </div>
    <div class="row space">
      <div class="col-md-4"><input class="form-control" type="text" id="mod_id" name="mod_id" placeholder="Mod ID" required value="<?=(isset($mod_id)) ? $mod_id : ""?>" /></div>
      <div class="col-md-5"> Mod ID</div>
    </div>
    <div class="row space">
      <div class="col-md-4"><input class="form-control" type="text" name="version_from" placeholder="Version From" readonly value="<?=(isset($version_from)) ? $version_from : "new"?>"/></div>
      <div class="col-md-5">Version From</div>
    </div>
    <div class="row space">
      <div class="col-md-4"><input class="form-control" type="text" name="version_to" placeholder="Version To" required value="<?=(isset($version_to)) ? $version_to : ""?>"/></div>
      <div class="col-md-5">Version To</div>
    </div>
    <div class="row space">
      <div class="col-md-4"><input class="form-control" type="text" name="description" placeholder="Optional" value="<?=(isset($description)) ? $description : ""?>"/></div>
      <div class="col-md-5">Description</div>
    </div>
    <?
    if ($update_mode == "true")
    {
      echo "<div class='row space'>
              <div class='col-md-4'><input class=\"form-control\" type='text' name='update_reason' placeholder='Update Reason' required /></div>
              <div class='col-md-5'>Update Reason</div>
            </div>";
    }
    ?>
    <div class="row space">
      <div class="col-md-12">
        <?= $switchIsRequired->GetControl() ?>
      </div>
    </div>
    <div class="row space">
      <div class="col-md-12">
        <?= $switchDefaultSelected->GetControl() ?>
      </div>
    </div>
    <div class="row space">
      <div class="col-md-12">
        <?= $switchSide->GetControl() ?>
      </div>
    </div>
    <!--
    <div class="row space">
      <?= generate_switch($is_required, "is_required", array("1" => "Required", "0" => "Optional")) ?>
    </div>
    <div class="row">
      <div class="three columns"><label><input class="form-control" type="checkbox" name="default_selected" <?=(isset($default_selected) && !$default_selected) ? "" : "checked"?> /> DEFAULT SELECTED</label></div>
    </div>
    <div class="row space">
      <?= generate_switch($pack_side, "pack_side", array("0" => "Server", "1" => "Both", "2" => "Client"), 2) ?>
    </div>
    -->
    <div class="row">
      <div class="eleven columns header" style="">Main File</div>
    </div>
    <div class="row" id="main_file_container">
      <?
      if (!isset($_GET['id']))
        echo "
          <div class=\"col-md-4\"><input class=\"form-control\" type=\"file\" name=\"mod_files[]\" required  onchange=\"on_file_change(event, false);\"/></div>
          <div class=\"col-md-2\">
            <select class=\"form-control\" name=\"file_types[]\">
              <option value=\"mod\">Mod</option>
              <option value=\"resource\">Resource</option>
              <option value=\"resource\">Config</option>
            </select>
          </div>
          <div class=\"col-md-5\"><input class=\"form-control\" type=\"text\" name=\"mod_paths[]\" required placeholder=\"Dir path (no filenames)\"/></div>
          <input type='hidden' name='entry_is_file[]' value='true' />
          <input type='hidden' name='is_sub_file[]' value='false' />";
      else
        echo "
          <div class=\"col-md-4\">".$row['filename']."</div>
          <input type='hidden' name='filename[]' value='".$row['filename']."' />
          <input type='hidden' name='system_file_name[]' value='".$row['system_file_name']."' />
          <div class=\"col-md-1\">".$row['file_type']."</div>
          <input type='hidden' name='file_types[]' value='".$row['file_type']."' />
          <div class=\"col-md-5\">".$row['path']."</div>
          <input type='hidden' name='mod_paths[]' value='".$row['path']."' />
          <div class='col-md-1'>
            <span class='button_upload' onclick='replace_main_file(this);' title='Replace file & Edit'></span>
            <span class='button_document' onclick='edit_main_file(this);' title='Edit (Do not replace file)'></span>
          </div>
          <input type='hidden' name='entry_is_file[]' value='false' />
          <input type='hidden' name='is_sub_file[]' value='false' />
          <input type='hidden' name='is_removed_file[]' value='false' />";
      ?>
    </div>
    <div class="row" id="sub_file_header">
      <div class="col-md-11 header">Dependencies/Config files</div>
    </div>
    <div class="row" id="file_upload_container">
      <?
      if (isset($sub_files))
      {
        foreach ($sub_files as $sub_file)
        {
          echo "
              <div class=\"col-md-4\">".$sub_file['filename']."</div>
              <input type='hidden' name='filename[]' value='".$sub_file['filename']."' />
              <input type='hidden' name='system_file_name[]' value='".$sub_file['system_file_name']."' />
              <div class=\"col-md-1\">".$sub_file['file_type']."</div>
              <input type='hidden' name='file_types[]' value='".$sub_file['file_type']."' />
              <div class=\"col-md-5\">".$sub_file['path']."</div>
              <input type='hidden' name='mod_paths[]' value='".$sub_file['path']."' />
              <input type='hidden' name='is_sub_file[]' value='true' />
              <input type='hidden' name='is_removed_file[]' value='false' />
              <div class='col-md-2'>
                <span class='btn button_upload' onclick='replace_sub_file(this);' title='Replace'></span>
                <span class='btn button_document' onclick='replace_sub_file(this);' title='Replace'></span>
                <span class='btn button_delete' onclick='disable_file(event);' title='Delete'></span>
              </div>
              <input type='hidden' name='entry_is_file[]' value='false' />";
        }
      }
      ?>
    </div>
    <div class="row">
      <div class="button_add_data" onclick="add_sub_file_upload(); event.preventDefault();" title="Add File"></div>
    </div>
    <div class="row" id="sub_dep_header" <?=((isset($sub_dependencies) && (count($sub_dependencies) > 0 || $sub_dependencies != "")) ? "" : "style='display: none;'")?>>
      <div class="col-md-11 header">Existing Dependencies</div>
    </div>
    <div class="row" id="existing_dependency_container">
      <?
      if (isset($sub_dependencies))
      {
        foreach ($sub_dependencies as $dep)
        {
          echo "
          <div class='col-md-4'>".$unique_mods[$dep]['name']."</div>
          <div class='col-md-5'>
            <span class='btn button_delete' onclick='this.parentElement.parentElement.parentElement.removeChild(this.parentElement.parentElement);' title='Delete'></span>
          </div>";
        }
      }
      ?>
    </div>
    <div class="row">
      <div class="button_add_data" onclick="add_existing_dependency(); event.preventDefault();" title="Add Existing Dependency"></div>
    </div>
    <div class="row" style="margin-top: 40px;">
      <div class="col-md-1">
        <button class="btn btn-primary" type="submit">Submit</button>
      </div>
      <div class="col-md-1">
        <a href="."><div class="btn btn-danger">Back</div></a>
      </div>
    </div>
    <div id="edit_container">

    </div>
  </form>
</div>
</body>
<script>
  console.log(JSON.parse('<?=str_replace("'", "\\'", json_encode($action_log))?>'));
  var mods = JSON.parse('<?=str_replace("'", "\\'", json_encode($unique_mods))?>');
  var debug_element = null;
  function replace_main_file(target)
  {
    var root = target.parentElement.parentElement;
    console.log(root);
    var container = document.getElementById("main_file_container");

    var div = document.createElement("div");
    div.className = "row";
    div.innerHTML = "<div class=\"col-md-4\"><input class=\"form-control\" type=\"file\" name=\"mod_files[]\" required /></div>" +
      "<div class=\"col-md-2\">" +
      "<select class=\"form-control\" name=\"file_types[]\">"+
      "<option value='mod' " + ((root.children[3].innerHTML === "mod") ? "selected" : "") + ">Mod</option>" +
      "<option value='resource' " + ((root.children[3].innerHTML === "resource") ? "selected" : "") + ">Resource</option>" +
      "</select>" +
      "</div>" +
      "<div class=\"col-md-5\"><input class=\"form-control\" type=\"text\" name=\"mod_paths[]\" placeholder=\"Path\" value='" + root.children[5].innerHTML + "'/></div>" +
      "<input type='hidden' name='entry_is_file[]' value='true' />";

    container.innerHTML = "";
    container.appendChild(div);
  }

  function edit_main_file(target)
  {
    var root = target.parentElement.parentElement;
    console.log(root);
    var container = document.getElementById("main_file_container");

    var div = document.createElement("div");
    div.className = "row";
    div.innerHTML = "<div class=\"col-md-4\">" + root.children[0].innerHTML + "</div>" +
      "<input type=\"hidden\" name=\"filename[]\" value=\"" + root.children[1].value + "\" />" +
      "<input type=\"hidden\" name=\"system_file_name[]\" value=\"" + root.children[2].value + "\" />" +
      "<div class=\"col-md-2\">" +
      "<select class=\"form-control\" name=\"file_types[]\">"+
      "<option value='mod' " + ((root.children[3].innerHTML === "mod") ? "selected" : "") + ">Mod</option>" +
      "<option value='resource' " + ((root.children[3].innerHTML === "resource") ? "selected" : "") + ">Resource</option>" +
      "</select>" +
      "</div>" +
      "<div class=\"col-md-5\"><input class=\"form-control\" type=\"text\" name=\"mod_paths[]\" placeholder=\"Path\" value='" + root.children[5].innerHTML + "'/></div>" +
      "<input type='hidden' name='entry_is_file[]' value='false' />";

    container.innerHTML = "";
    container.appendChild(div);
  }

  function replace_sub_file(target)
  {
    var root = target.parentElement.parentElement;
    console.log(root);
    var container = document.getElementById("main_file_container");

    var div = document.createElement("div");
    div.className = "row";
    div.innerHTML = "<div class=\"col-md-4\"><input class=\"form-control\" type=\"file\" name=\"mod_files[]\" required /></div>" +
      "<div class=\"col-md-2\">" +
      "<select class=\"form-control\" name=\"file_types[]\">"+
      "<option value='config' " + ((root.children[3].innerHTML === "config") ? "selected" : "") + ">Config</option>" +
      "<option value='library' " + ((root.children[3].innerHTML === "library") ? "selected" : "") + ">Library</option>" +
      "</select>" +
      "</div>" +
      "<div class=\"col-md-5\"><input class=\"form-control\" type=\"text\" name=\"mod_paths[]\" placeholder=\"Path\" value='" + root.children[5].innerHTML + "'/></div>" +
      "<input type='hidden' name='entry_is_file[]' value='true' />";

    root.innerHTML = div.innerHTML;
  }

  function add_sub_file_upload()
  {
    var container = document.getElementById("file_upload_container");

    var div = document.createElement("div");
    div.className = "row";
    div.innerHTML = "" +
      "<div class=\"col-md-4\"><input class=\"form-control\" type=\"file\" name=\"mod_files[]\" onchange=\"on_file_change(event)\" required /></div>" +
      "<div class=\"col-md-2\">" +
        "<select class=\"form-control\" name=\"file_types[]\">"+
          "<option value=\"library\">Dependency</option>" +
          "<option value=\"config\">Config</option>" +
        "</select>" +
      "</div>" +
      "<div class=\"col-md-5\"><input class=\"form-control\" type=\"text\" name=\"mod_paths[]\" placeholder=\"Path\"/></div>" +
      "<input type='hidden' name='entry_is_file[]' value='true' />" +
      "<input type='hidden' name='is_sub_file[]' value='true' />" +
      "<input type='hidden' name='is_removed_file[]' value='false' />" +
      "<div class=\"col-md-1\"><span class=\"button_delete\" onclick=\"this.parentElement.parentElement.parentElement.removeChild(this.parentElement.parentElement);\"></span></div>";
    container.appendChild(div);
    document.getElementById("sub_file_header").style.display = null;
  }

  function on_file_change(event, set_type, is_primary)
  {
    if (typeof set_type === "undefined")
      set_type = true;
    var type_element = event.target.parentElement.parentElement.children[1].children[0];
    var path_element = event.target.parentElement.parentElement.children[2].children[0];
    var filename = event.target.files[0].name;

    if (filename.indexOf(".jar") !== -1)
    {
      if (set_type)
        type_element.selectedIndex = 0;
      path_element.value = "mods/";
    }
    else if (filename.indexOf(".cfg") !== -1 || filename.indexOf(".xml") !== -1 || filename.indexOf(".json") !== -1 || filename.indexOf(".ini") !== -1 || filename.indexOf(".dat") !== -1 || filename.indexOf(".txt") !== -1)
    {
      if (set_type)
        type_element.selectedIndex = 1;
      path_element.value = "config/";
    }
  }

  function add_existing_dependency()
  {
    var container = document.getElementById("existing_dependency_container");
    var div = document.createElement("div");

    var mod_options = "";
    for (var key in mods)
    {
      let mod = mods[key];
      mod_options += "<option value='" + mod.id + "'>" + mod.name + " " + mod.version + "</option>";
    }

    div.className = "row";
    div.innerHTML = "<div class='col-md-4'>Depends on </div>" +
      "<div class='col-md-4'>" +
      "<select class=\"form-control\" name='existing_dependencies[]'>" +
      mod_options +
      "</select>" +
      "</div>" +
      "<div class='col-md-1'><span class='button_delete' onclick='this.parentElement.parentElement.parentElement.removeChild(this.parentElement.parentElement);'></span></div>";
    container.appendChild(div);
    document.getElementById("sub_dep_header").style.display = null;
  }

  function input_blur(event)
  {
    if (event.target.hasOwnProperty("value"))
      event.target.value = event.target.value.replace(",", "").replace(" ", "_");
  }

  function disable_file(event)
  {
    var elements = event.target.parentElement.parentElement.children;
    for (let i = 0; i < elements.length; i++)
    {
      let element = elements[i];
      if (element.tagName == "DIV")
      {
        element.style.color = "dimgray";
      }
      else if (element.tagName == "INPUT" && element.name == "is_removed_file[]")
      {
        element.value = "true";
      }
    }
    event.target.className = "button_undo";
    event.target.onclick = undo_disable_file;
  }

  function undo_disable_file(event)
  {
    var elements = event.target.parentElement.parentElement.children;
    for (let i = 0; i < elements.length; i++)
    {
      let element = elements[i];
      if (element.tagName == "DIV")
      {
        element.style.color = null;
      }
      else if (element.tagName == "INPUT" && element.name == "is_removed_file[]")
      {
        element.value = "false";
      }
    }
    event.target.className = "button_delete";
    event.target.onclick = disable_file;
  }

  function quick_edit(event)
  {

  }
</script>
</html>