<?
die("Unavailable... sorry");

require_once "../inc_functions.php";
require_once "../auth.php";

die("Auto update is not available due to FTP issues.");
$session = get_login_session("admin");
?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Auto Update - ForeModpacker</title>
  <script src="//towerofawesome.org/libraries_javascript/jquery.min.js"></script>
  <link rel='stylesheet' href='../assets/bootstrap.min.css' />
  <script src='../assets/bootstrap.min.js'></script>
  <script src='../assets/cookie_functions.min.js'></script>
  <link rel='stylesheet' href='../assets/styles.css' />
  <script src="../internal/functions.js"></script>
  <style>
    .error_line, .info_line, .success_line
    {
      padding-left : 4px;
    }

    .error_line
    {
      background-color : orangered;
      color            : white;
    }

    .info_line
    {
      background-color : #9ad9ff;
      color            : black;
    }

    .success_line
    {
      background-color : forestgreen;
      color            : white;
    }
  </style>
</head>
<body>
<div class="overlay" id="overlay" style="display: block;"></div>
<div class="new_user_popup" id="start_popup">
  <div>Before the update process is started make sure:</div>
  <div>
    <ol>
      <li>you've pushed a new tag</li>
      <li>the server has shut down correctly and wont start up during the update</li>
      <li>to reticulate the splines</li>
    </ol>
  </div>
  <div style="text-align: center; margin-top: 20px;">
    <button class="button-primary" onclick="prepare_update();">START</button>
  </div>
</div>
<div class="new_user_popup" id="continue_popup" style="display: none;">
  <div id="continue_popup_text"></div>
  <div style="text-align: center; margin-top: 20px;">
    <button class="button-primary" onclick="this.parentElement.parentElement.style.display = 'none'; upload_next_file();">
      CONTINUE
    </button>
  </div>
</div>
<div id="log_container">
</div>
</body>
<script>
  var log = document.getElementById("log_container");
  var current_upload_index = -1;
  var files_to_upload;
  var current_retries = 0;
  var max_retries = 5;
  function prepare_update()
  {
    document.getElementById("overlay").style.display = "none";
    document.getElementById("start_popup").style.display = "none";
    $.post("../api/auto_update_prepare.php")
      .done(function (payload)
      {
        payload = JSON.parse(payload);
        if (payload['result'] == 0)
        {
          log.innerHTML += "<div class='info_line'>Deleted " + payload['successes'] + " out of " + payload['operations'] + " files</div>";
          log.innerHTML += "<div class='info_line'>" + payload['files_to_upload'].length + " files to upload</div>";
          console.log(payload['files_to_upload']);
          console.info(payload['log']);
          files_to_upload = payload['files_to_upload'];
          if (files_to_upload.length > 0)
          {
            document.getElementById("continue_popup_text").innerHTML = files_to_upload.length + " files queued for upload.";
            document.getElementById("continue_popup").style.display = "block";
          }
          else
          {
            log.innerHTML += "<div class='success_line'>No files to upload. Update complete!</div>";
            update_time();
          }
        }
        else
        {
          console.warn(payload['msg'], payload['details']);
          log.innerHTML += "<div class='error_line'>" + payload['msg'] + "</div>";
        }
      })
      .fail(function (payload)
      {
        console.warn(payload);
        log.innerHTML += "<div class='error_line'>Server connection failed (" + payload.status + ") for prepare call</div>";
      });
  }

  function upload_next_file()
  {
    current_upload_index++;
    var current_entry;
    if (typeof files_to_upload[current_upload_index] != "undefined")
    {
      current_entry = files_to_upload[current_upload_index];
      console.log(current_entry);
      $.post("../api/auto_update_upload_file.php", {entry_id: current_entry['id']})
        .done(function (payload)
        {
          payload = JSON.parse(payload);
          if (payload.result == 0)
          {
            log.innerHTML += "<div class='success_line'>Uploaded file '" + current_entry['path'] + current_entry['filename'] + "</div>";
            current_retries = 0;
            upload_next_file();
          }
          else
          {
            console.warn(payload['msg'], payload['details']);
            log.innerHTML += "<div class='error_line'>" + payload['msg'] + "</div>";
            if (current_retries < max_retries)
            {
              log.innerHTML += "<div class='info_line'>Retrying (" + current_retries + "/" + max_retries + ")</div>";
              setTimeout(upload_next_file, 1000);
            }
            else
              log.innerHTML += "<div class='error_line'>Too many retries. Stopping.</div>";
          }
        })
        .fail(function (payload)
        {
          console.warn(payload);
          log.innerHTML += "<div class='error_line'>Server connection failed (" + payload.status + ") for upload call for index " + current_upload_index + "</div>";
        });
    }
    else
    {
      log.innerHTML += "<div class='info_line'>Update complete</div>";
      update_time();
    }
  }

  function update_time()
  {
    $.post("../api/auto_update_set_time.php")
      .done(function (payload)
      {
        payload = JSON.parse(payload);
        if (payload.result == 0)
        {
          log.innerHTML += "<div class='info_line'>Time of last update set</div>";
        }
        else
        {
          console.warn(payload['msg'], payload['details']);
          log.innerHTML += "<div class='error_line'>" + payload['msg'] + "</div>";
        }
      })
      .fail(function (payload)
      {
        console.warn(payload);
        log.innerHTML += "<div class='error_line'>Server connection failed (" + payload.status + ") for upload call for index " + current_upload_index + "</div>";
      });
  }
</script>
</html>