<?
//Created 30/04/2017
require_once "../internal/inc_connect.php";
require_once "krumo/class.krumo.php";
require_once "../inc_functions.php";
require_once "inc_common_functions.php";

$valid_extensions = array("cfg", "ini", "conf", "txt", "json", "zs", "recipes", "properties", "xml");

$log = array();
$error = 0;
$files = array();
if (isset($_GET['id']) || isset($_POST['id']))
{
  if (isset($_GET['id']))
    $id = $_GET['id'];
  else
    $id = $_POST['id'];
  $result = mysqli_query($con, "SELECT * FROM files WHERE mod_id = '$id' ORDER BY id DESC LIMIT 1");

  if ($result)
  {
    $row = mysqli_fetch_assoc($result);
    $files[] = array_merge(array("is_main" => true), $row);

    $result = mysqli_query($con, "SELECT * FROM files WHERE parent_identifier = '" . $row['update_id'] . "' AND version_to != 'removed'");

    if ($result)
    {
      while ($sub_file = mysqli_fetch_assoc($result))
      {
        $files[] = array_merge(array("is_main" => false), $sub_file);
      }
    }
    else
      $error = 1;
  }
  else
    $error = 1;
}

if (isset($_POST['fanfare']))
{
  $new_files = array();
  $changed_files = 0;
  foreach ($files as $file)
  {
    if (isset($_POST[str_replace(".", "_", $file['filename'])]))
    {
      $log[] = "Found file " . str_replace(".", "_", $file['filename']) . " in post data";
      $old_file = file_get_contents("../files/" . $file['system_file_name']);
      if ($old_file != $_POST[str_replace(".", "_", $file['filename'])])
        $changed_files++;
      else
        $log[] = "File " . str_replace(".", "_", $file['filename']) . " has not changed";
    }
    else
      $log[] = "No file " . str_replace(".", "_", $file['filename']) . " in post data";
  }

  if ($changed_files > 0)
  {
    $save_operations_success = 0;
    $save_operations = 0;
    $update_id = uniqid();
    foreach ($files as $file)
    {
      $values = array(
        "mod_name" => mysqli_escape($con, $file['mod_name']),
        "mod_id" => mysqli_escape($con, $file['mod_id']),
        "system_file_name" => "",
        "filename" => mysqli_escape($con, $file['filename']),
        "file_type" => mysqli_escape($con, $file['file_type']),
        "path" => mysqli_escape($con, $file['path']),
        "update_id" => "",
        "parent_identifier" => "",
        "update_time" => time(),
        "version_from" => mysqli_escape($con, $file['version_to']),
        "version_to" => mysqli_escape($con, $file['version_to']),
        "is_required" => mysqli_escape($con, $file['is_required']),
        "pack_side" => mysqli_escape($con, $file['pack_side']),
        "other_dependencies" => mysqli_escape($con, $file['other_dependencies']),
        "default_selected" => mysqli_escape($con, $file['default_selected']),
        "update_reason" => mysqli_escape($con, $_POST['update_reason']),
        "description" => mysqli_escape($con, $file['description'])
      );
      if ($file['is_main'])
        $values['update_id'] = mysqli_escape($con, $update_id);
      else
        $values['parent_identifier'] = mysqli_escape($con, $update_id);

      if (isset($_POST[str_replace(".", "_", $file['filename'])]))
      {
        $old_file = file_get_contents("../files/" . $file['system_file_name']);
        $new_file = $_POST[str_replace(".", "_", $file['filename'])];
        if ($old_file !== false && $new_file != $old_file)
        {
          $log[] = "Detected changes when saving file " . str_replace(".", "_", $file['filename']);
          $new_system_file_name = uniqid($file['filename'] . "-");
          $new_file_result = file_put_contents("../files/" . $new_system_file_name, $new_file);
          $log[] = "Saving new file " . $new_system_file_name . ": " . (($new_file_result) ? "true" : "false");
          $values['system_file_name'] = mysqli_escape($con, $new_system_file_name);
        }
        else
        {
          $log[] = "No changes in file " . str_replace(".", "_", $file['filename']) . " when saving";
          $values['system_file_name'] = mysqli_escape($con, $file['system_file_name']);
        }
        if ($old_file === false)
          $log[] = "Loading old file failed for ../files/" . $file['system_file_name'];
      }
      else
        $values['system_file_name'] = mysqli_escape($con, $file['system_file_name']);

      $query_result = mysqli_query($con, build_query("files", $values));
      if (!$query_result)
        log_file("Query failed: " . mysqli_error($con), "../sql.log");
      $save_operations_success += $query_result;
      $save_operations++;
    }
    if ($save_operations == $save_operations_success)
      $result = 0;
    else
      $result = urlencode("Only $save_operations_success/$save_operations operations succeeded");
    header("Location: .?result=$result");
  }
}

?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Edit - ForeModpacker</title>
  <link rel='stylesheet' href='../assets/bootstrap.min.css' />
  <script src='../assets/bootstrap.min.js'></script>
  <script src='../assets/cookie_functions.min.js'></script>
  <link rel='stylesheet' href='../assets/styles.css' />
  <style>
    textarea
    {
      transition-property : height;
      transition-duration : 1s;
      resize              : none;
    }
  </style>
</head>
<body class="container">
<?
if (isset($changed_files) && $changed_files == 0)
{
  ?> <div>No files were changed.</div> <?
}
if (isset($save_operations) && $save_operations == 0)
{
?> <div>No saving took place...</div> <?
}
?>
<form action="" method="post">
  <input type="hidden" name="fanfare" value="true" />
  <div style="margin-bottom: 20px;">
    <input type="text" class="form-control" name="update_reason" required placeholder="Update Reason" />
  </div>
  <?
  if (count($files) > 0)
  {
    foreach ($files as $file)
    {
      echo "<div style='margin-bottom: 20px;'>";
      echo "<div>" . $file['path'] . $file['filename'] . "</div>";
      $exp = explode(".", $file['filename']);
      $exp = array_reverse($exp);
      if (in_array($exp[0], $valid_extensions))
        echo "<div><textarea class='form-control' name='" . $file['filename'] ."' onfocus='area_focus(event);' onblur='area_blur(event);'>" . file_get_contents("../files/" . $file['system_file_name']) . "</textarea></div>";
      else
        echo "<div style='color: red;'>Cannot edit this file</div>";
      echo "</div>";
    }
  }
  else
    echo "This entry has no editable files.";
  ?>
  <div>
    <button class="btn btn-success">Save Changes</button>
    <a href="." class="btn btn-primary">Back</a>
  </div>
</form>
</body>
<script>
  console.log(JSON.parse('<?=json_encode($log)?>'));

  function area_focus(event)
  {
    event.target.style.height = "500pt";
  }

  function area_blur(event)
  {
    event.target.style.height = null;
  }
</script>
</html>