<?
//Created 2016-03-29
require_once "../internal/inc_connect.php";
require_once "../inc_functions.php";
require_once "inc_common_functions.php";
require_once "krumo/class.krumo.php";
require_once "../constants.php";
require_once "../classes/Role.php";
require_once "../classes/SimpleSetting.php";
require_once "../classes/OldMenu.php";
require_once "../auth.php";

db_init();
debug_init();

list($session, $email) = get_login_session("mod");

$error = "";
$page_title = "";
$role = new Role();
$simpleSettings = new SimpleSetting();
$settings = array();

if ($simpleSettings->Load(SimpleSetting::$MAINTENANCE_MODE)->TestEnabled())
  die("<link rel='stylesheet' href='../assets/styles.css'/><div class='death_note'><div>System is in maintenance mode!</div><div>Check back later!</div></div>");

if (isset($_POST['new_user_email']))
{
  $new_user_email = mysqli_escape($con, $_POST['new_user_email']);
  $new_user_role = mysqli_escape($con, $_POST['new_user_role']);
  $new_user_minecraft_name = mysqli_escape($con, $_POST['new_user_minecraft_name']);
  $new_user_note = mysqli_escape($con, $_POST['new_user_note']);
  $email_update = ($new_user_email != "") ? ", email = '$new_user_email'" : "";
  $query = "INSERT INTO users (email, role, minecraft_name, note) VALUES ('$new_user_email', '$new_user_role', '$new_user_minecraft_name', '$new_user_note') ON DUPLICATE KEY UPDATE role = '$new_user_role', minecraft_name = '$new_user_minecraft_name', note = '$new_user_note'$email_update";
  $result = mysqli_query($con, $query);
  if (!$result)
    log_file(mysqli_error($con), "../sql.log");
}

$tag = get_latest_tag($dev_mode);

handle_setting($simpleSettings::$PAGE_TITLE);
handle_setting($simpleSettings::$FORGE_VERSION);
handle_setting($simpleSettings::$DOWNLOADS_ENABLED);
handle_setting($simpleSettings::$USER_LOGIN);
handle_setting($simpleSettings::$MEDIA_STREAM_FOLLOWER);
handle_setting($simpleSettings::$MEDIA_STREAM_VIEWS);
handle_setting($simpleSettings::$MEDIA_VIDEO_FOLLOWER);
handle_setting($simpleSettings::$MEDIA_VIDEO_VIEWS);
handle_setting($simpleSettings::$MEDIA_NOTE);
handle_setting($simpleSettings::$WHITELIST_UPDATE);
handle_setting($simpleSettings::$PUSH_NOTIFICATIONS);
handle_setting($simpleSettings::$MIN_TIME_BEFORE_REPEAT);

$query = "SELECT * FROM files WHERE file_type = 'mod' OR file_type = 'resource' ORDER BY update_time ASC";
$result = mysqli_query($con, $query);

$mods = array();
if ($result && mysqli_num_rows($result) > 0)
{
  while ($row = mysqli_fetch_assoc($result))
  {
    $mods[$row['mod_id']] = $row;
  }

  $mods = array_order_by($mods, "mod_name", SORT_ASC);
}
else if (!$result)
  $error = "SQL Error";
else if (mysqli_num_rows($result) == 0)
  $error = "No files found";

//$query = "SELECT * FROM misc WHERE field_key = 'page_title'";
//$result = mysqli_query($con, $query);
//if ($result && mysqli_num_rows($result) == 1)
//{
//  $page_title = mysqli_fetch_assoc($result);
//  $page_title = $page_title['field_value'];
//}
?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Admin - <?=$simpleSettings->Load(SimpleSetting::$PAGE_TITLE)->Value()?></title>
  <script src='../assets/jquery-1.12.0.min.js'></script>
  <link rel='stylesheet' href='../assets/bootstrap.min.css' />
  <script src='../assets/bootstrap.min.js'></script>
  <script src='../assets/cookie_functions.min.js'></script>
  <link rel='stylesheet' href='../assets/styles.css' />
  <script src="../internal/functions.js"></script>
  <style>
    .light-row:nth-child(2n+1)
    {
      background-color: #555555;
    }
  </style>
</head>
<body>
<?php require_once "../overlay_spinner.html"; ?>
<div id="server_generate_dialog" class="container modal_dialog" style="display: none;">
  <div class="row">
    <div><h4>Generate server pack</h4></div>
  </div>
  <div class="row">
    <div>
      <select id="server_patch_from" title="Patch Mode">
        <option value="null">Full Pack</option>
        <?
        $result = mysqli_query($con, "SELECT * FROM tags ORDER BY id DESC");
        if ($result)
        {
          $row = mysqli_fetch_assoc($result);
          while ($row = mysqli_fetch_assoc($result))
            echo "<option value='" . $row['tag'] . "'>Patch from " . $row['tag'] . "</option>";
        }
        ?>
      </select></div>
  </div>
  <div class="row">
    <div style="text-align: center;"><button class="button-primary" onclick="request_server_pack(); hide_server_generate_dialog();">Generate</button></div>
  </div>
</div>
  <?
  $menu_root = "../";
  $menu = get_admin_menu();
  echo $menu->BuildMenu();
  ?>
<div style="padding: 20px;" class="container-fluid">
  <?
  if (isset($_GET['result']))
  {
    if ($_GET['result'] == 0)
      echo "<div class='row yay' id='redirect_result' onclick='this.style.display = \"none\";'>Success</div>";
    else
      echo "<div class='row error' id='redirect_result' onclick='this.style.display = \"none\";'>Ohno, something went wrong... (" . $_GET['result'] . ")</div>";
  }
  ?>
  <div class="row">
    <div class="col-md-2"><input class="form-control" type="text" id="tag_release" placeholder="Tag" maxlength="40" value="<?=$tag?>" /></div>
    <div class="col-md-2" id="tag_release_result">To release new tag, name the tag in the field to the left and click "Release Tag"</div>
  </div>
  <div class="row">
    <div class="col-md-2">
      <select id="tag_type" title="Tag Type" class="form-control">
        <option value="major">Major</option>
        <option value="minor">Minor (server-only)</option>
      </select>
    </div>
    <div class="col-md-1"><button class="btn btn-primary" onclick="release_tag();">Release Tag</button></div>
  </div>
  <div style="margin-top: 24px;"></div>
  <?
  $result = mysqli_query($con, "SELECT id FROM files WHERE release_tag IS NULL OR release_tag = ''");
  $row_count = 0;
  if ($result)
    $row_count = mysqli_num_rows($result);
  ?>
  <div class="row">
    <div class="col-md-2 title">Mod Name</div>
    <div class="col-md-2 title">Mod Id</div>
    <div class="col-md-3 title">File</div>
    <div class="col-md-2 title">Version</div>
    <div class="col-md-1 title">Controls</div>
    <div class="col-md-2 title">States</div>
  </div>
  <?php
  $row_a = "<div class='main light-row'>
              <div class='row' {extra}>
                <div class='col-md-2'>{name}</div>
                <div class='col-md-2'>{mod_id}</div>
                <div class='col-md-3'>{file}</div>
                <div class='col-md-2'>{version}</div>
                <div class='col-md-1'>{controls}</div>
                <div class='col-md-1'>{states}</div>
                {sub_control}
              </div>
              <div class='main' style='display: none;'>
                {sub_files}
              </div>
            </div>";
  $counter = 0;
  foreach ($mods as $mod)
  {
    if ($mod['version_to'] != "removed")
    {
      $counter++;
      $query = "SELECT * FROM files WHERE parent_identifier = '".$mod['update_id']."' OR other_dependencies LIKE ('".$mod['mod_id']."') ORDER BY update_time ASC";
      $result = mysqli_query($con, $query);
      $sub_mods = array();
      $sub_rows = "";
      if ($result && mysqli_num_rows($result) > 0)
      {
        while ($row = mysqli_fetch_assoc($result))
        {
          if ($row['version_to'] != "removed")
            $sub_mods[$row['mod_id']] = $row;
        }
      }
      $sub_rows .= insert($row_a, array(
        "name" => strtoupper("MAIN"),
        "mod_id" => "",
        "version" => "",
        "file" => $mod['path'] . $mod['filename'],
        "controls" => "",
        "states" => "",
        "extra" => "style='padding-left: 15px; color: #949494;'",
        "sub_files" => "",
        "sub_control" => "<a title='Download " . $mod['filename'] . "' href='../api/get_file?id=" . $mod['id'] . "'><span class='button_download'></span></a>"
      ));
      foreach ($sub_mods as $sub_mod)
      {
        if ($sub_mod['version_to'] != "removed")
        {
          $sub_rows .= insert($row_a, array(
            "name" => strtoupper($sub_mod['file_type']),
            "mod_id" => "",
            "version" => "",
            "file" => $sub_mod['path'] . $sub_mod['filename'],
            "controls" => "",
            "states" => "",
            "extra" => "style='padding-left: 15px; color: #949494;'",
            "sub_files" => "",
            "sub_control" => "<a title='Download " . $sub_mod['filename'] . "' href='../api/get_file?id=" . $sub_mod['id'] . "'><span class='button_download'></span></a>"
          ));
        }
      }

      echo insert($row_a, array(
        "name" => $mod['mod_name'],
        "mod_id" => $mod['mod_id'],
        "version" => $mod['version_to'],
        "file" => "",
        "controls" => "<a title='Update' href='add?id=" . $mod['id'] . "'><span class='button_upload'></span></a>
                       <a title='Quick-edit' href='edit?id=" . $mod['mod_id'] . "'><span class='button_document'></span></a>
                       <a title='Remove' href='rem?id=" . $mod['id'] . "'><span class='button_delete'></span></a>",
        "states" => (($mod['pack_side'] == 0) ? get_badge("Server", "danger") : "") . (($mod['pack_side'] == 2) ? get_badge("Client") : "") . ((!$mod['is_required']) ? get_badge("Optional", "success") : ""),
        "extra" => "",
        "sub_files" => $sub_rows,
        "sub_control" => ($sub_rows !== "") ? "<dim><div class='two columns pnt' onclick='more_info_show(event)'>Show ".(count($sub_mods) + 1)." file(s)</div></dim>" : ""
      ));
    }

  }
  if ($counter == 0)
    echo "<div class='row'>There are no mods to list</div>";
  ?>
</div>
<? include_once "../footer.php"; ?>
</body>
<script>
  var last_change = null;
  var redirect_result = document.getElementById("redirect_result");
  if (typeof redirect_result != "undefined" && redirect_result != null)
    setTimeout(function(redirect_result) {redirect_result.style.opacity = 0;}, 5000, redirect_result);

  function more_info_show(event)
  {
    event.target.onclick = more_info_hide;
    event.target.innerHTML = event.target.innerHTML.replace("Show", "Hide");
    // event.target.parentElement.parentElement.parentElement.children[1].style.display = null;
    $(event.target.parentElement.parentElement.parentElement.children[1]).show("fast");
  }

  function more_info_hide(event)
  {
    event.target.onclick = more_info_show;
    event.target.innerHTML = event.target.innerHTML.replace("Hide", "Show");
    // event.target.parentElement.parentElement.parentElement.children[1].style.display = "none";
    $(event.target.parentElement.parentElement.parentElement.children[1]).hide("fast");
  }

  function request_server_pack()
  {
    var params = { server_mode: "true" };
    var patch_from = document.getElementById("server_patch_from").value;
    if (patch_from != "null")
      params['from'] = patch_from;
    overlay_spinner_on();
    document.getElementById("spinner_text").innerHTML = "Generating...";
    $.post("../internal/generate_archive.php", params)
      .done(function(payload)
      {
        payload = JSON.parse(payload);
        console.info(payload);
        if (payload.result === 0)
          document.getElementById("spinner_text").innerHTML = "<a class='download_link' href='../archives/server_pack.zip'>Download</a><br/>Size: " + payload['size'] + "<br/>Mods: " + payload['count_mods'] + "<br/>Optional: " + payload['count_mods_opt'] + "<br/>Resource Packs: " + payload['count_resources'] + "<br/><span onclick='overlay_off();' class='dim pnt'>Close</span>";
        else
          document.getElementById("spinner_text").innerHTML = "<span class='error'>" + payload['msg'] + "</span>";
        spinner_off();
      })
      .fail(function(payload)
      {
        console.error(payload);
        document.getElementById("spinner_text").innerHTML = "<span class='error'>An error occurred calling API (" + payload.status + ")</span>";
        spinner_off();
      });
  }

  function request_client_pack(dev_mode)
  {
    var args = {};
    if (typeof dev_mode != "undefined" && dev_mode != null && dev_mode == true)
      args['include_untagged'] = true;
    overlay_spinner_on();
    document.getElementById("spinner_text").innerHTML = "Generating...";
    $.post("../internal/generate_archive.php", args)
      .done(function(payload)
      {
        payload = JSON.parse(payload);
        if (payload.result === 0)
          if (!dev_mode)
            document.getElementById("spinner_text").innerHTML = "<a class='download_link' href=" + payload['id'] + "'../internal/get_file?id=&type=build'>Download</a><br/>Size: " + payload['size'] + "<br/>Mods: " + payload['count_mods'] + "<br/>Optional: " + payload['count_mods_opt'] + "<br/>Resource Packs: " + payload['count_resources'] + "<br/><span onclick='overlay_off();' class='dim pnt'>Close</span>";
        else
            document.getElementById("spinner_text").innerHTML = "<a class='download_link' href='../archives/modpack-test-client.zip'>Download</a><br/>Mods: " + payload['count_mods'] + "<br/>Optional: " + payload['count_mods_opt'] + "<br/>Resource Packs: " + payload['count_resources'] + "<br/><span onclick='overlay_off();' class='dim pnt'>Close</span>";
        else
          document.getElementById("spinner_text").innerHTML = "<span class='error'>" + payload['msg'] + "</span>";
        spinner_off();
      })
      .fail(function(payload)
      {
        console.error(payload);
        document.getElementById("spinner_text").innerHTML = "<span class='error'>An error occurred calling API (" + payload.status + ")</span>";
        spinner_off();
      });
  }

  function toggle_user_list(event)
  {
    var list = document.getElementById("user_list_container");
    if (list.style.display === "none")
    {
      list.style.display = null;
      event.target.innerHTML = event.target.innerHTML.replace("Show", "Hide");
    }
    else
    {
      list.style.display = "none";
      event.target.innerHTML = event.target.innerHTML.replace("Hide", "Show");
    }
  }

  function toggle_settings(event)
  {
    var list = document.getElementById("settings_container");
    if (list.style.display === "none")
    {
      list.style.display = null;
      event.target.innerHTML = event.target.innerHTML.replace("Show", "Hide");
    }
    else
    {
      list.style.display = "none";
      event.target.innerHTML = event.target.innerHTML.replace("Hide", "Show");
    }
  }

  function release_tag()
  {
    var output = document.getElementById("tag_release_result");
    var tag = document.getElementById("tag_release").value;
    var tag_type = document.getElementById("tag_type").value;
    if (tag.length < 3)
      output.innerHTML = "Tag too short";
    else if (tag.length > 40)
      output.innerHTML = "Tag too long (Max 40)";
    else
    {
      $.post("../internal/release_tag.php", {release_tag: tag, tag_type: tag_type})
        .done(function(payload)
        {
          payload = JSON.parse(payload);
          if (payload.result === 0)
            output.innerHTML = "Release successfully tagged!";
          else
            output.innerHTML = payload['msg'];
        })
        .fail(function(payload)
        {
          output.innerHTML = "Failed to call API (" + payload.status + ")";
        })
    }
  }

  function populate_user_fields(event)
  {
    var elements = event.target.parentElement.children;
    document.getElementById("new_user_minecraft_name").value = elements[0].innerHTML;
    var options = document.getElementById("new_user_role").children;
    for (let i = 0; i < options.length; i++)
    {
      if (options[i].innerHTML == elements[1].innerHTML)
        options[i].selected = true;
    }
    document.getElementById("new_user_note").value = elements[3].title;
  }

  function show_server_generate_dialog()
  {
    document.getElementById("server_generate_dialog").style.display = null;
  }

  function hide_server_generate_dialog()
  {
    document.getElementById("server_generate_dialog").style.display = "none";
  }

  function check_for_changes()
  {
    console.info("Test");
    $.post("../internal/get_last_change.php")
      .done(function(payload)
      {
        payload = JSON.parse(payload);
        var message = "Unknown state";
        if (payload.result == 0)
        {
          if (last_change == null)
          {
            last_change = payload["id"];
            message = "";
          }
          else
          {
            if (last_change != payload["id"])
              message = "Changes detected! Please reload the page!";
            else
              message = "";
          }
        }
        else
          message = payload["msg"];

        // console.info(message);
        if (message != "")
        {
          document.getElementById("overlay").style.display = "block";
          document.getElementById("spinner_text").style.display = "block";
          document.getElementById("spinner_text").style.fontSize = "16pt";
          document.getElementById("spinner_text").innerHTML = message;
          clearInterval(update_check_id);
        }
      })
      .fail(function(payload)
      {
        document.getElementById("overlay").style.display = null;
        document.getElementById("spinner_text").style.display = null;
        document.getElementById("spinner_text").innerHTML = "Unable to connect to server to check for updates! (" + payload.code + ")";
        clearInterval(update_check_id);
      });
  }

  check_for_changes();
  var update_check_id = setInterval(check_for_changes, 10000);
</script>
</html>