<?
//Created 25/05/2017
require_once "../internal/inc_connect.php";
require_once "../inc_functions.php";
require_once "../classes/Role.php";
require_once "krumo/class.krumo.php";

list($session, $email) = get_login_session("admin");

$role = new Role();

$error = "";
if (isset($_POST['mode']))
{
  $form_email = mysqli_escape($con, $_POST['email']);
  $form_role = mysqli_escape($con, $_POST['role']);
  $form_note = mysqli_escape($con, $_POST['note']);
  if (!isset($form_role) || $form_role == "")
    $error = "No role provided";
  elseif ($_POST['mode'] == "add")
  {
    if (!isset($form_email) || $form_email == "")
      $error = "No email provided";
    else
    {
      $query = "INSERT INTO users (email, role, note) VALUES ('$form_email', '$form_role', '$form_note')";
      $result = mysqli_query($con, $query);

      if (!$result)
        $error = "An error occurred while adding new user: " . mysqli_error($con);
    }
  }
  else
  {
    $form_email = $_POST['mode'];
    $query = "UPDATE users SET role = '$form_role' WHERE email = '$form_email'";
    $result = mysqli_query($con, $query);

    if (!$result)
      $error = "An error occurred while updating user: " . mysqli_error($con);
  }
}

$sort = "role";
if (isset($_GET['sort']))
{
  if ($_GET['sort'] == "name")
    $sort = "minecraft_name";
  elseif ($_GET['sort'] == "email")
    $sort = "email";
  elseif ($_GET['sort'] == "login")
    $sort = "token_expires";
}

$query = "SELECT * FROM users ORDER BY $sort ASC";
$result = mysqli_query($con, $query);

?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>User Management - ForeModpacker</title>
  <link rel='stylesheet' href='../assets/bootstrap.min.css' />
  <script src='../assets/bootstrap.min.js'></script>
  <script src='../assets/cookie_functions.min.js'></script>
  <link rel="stylesheet" href="../assets/styles.css" />
  <style>
    .row:nth-child(2n)
    {
      background-color: rgba(0,0,0,0.16);
    }

    .row:hover
    {
      background-color: royalblue;
    }

    a, a:visited, a:hover
    {
      text-decoration: none;
    }

    a:hover
    {
      color: white;
    }

    @keyframes float_up
    {
      0%     { top: -10px; opacity: 0; }
      50%    { top: -30px; opacity: 1; }
      100%   { top: -30px; opacity: 0; }
    }

    .float_up
    {
      position           : absolute;
      top                : -30px;
      opacity            : 0;
      background-color   : white;
      color              : black;
      padding            : 5px;
      border-radius      : 5px;
      animation-name     : float_up;
      animation-duration : 3s;
    }
  </style>
</head>
<body>
<div>
  <?
  $menu = array(
    "Back" => array("type" => "link", "url" => "."),
    "Sort by..." => array(
      "type" => "menu",
      "items" => array(
        "Email" => array("type" => "link", "url" => "?sort=email"),
        "Name" => array("type" => "link", "url" => "?sort=name"),
        "Role" => array("type" => "link", "url" => "?sort=role"),
        "Login" => array("type" => "link", "url" => "?sort=login"),
      )
    )
  );
  build_menu();
  ?>
</div>
<div class="container">
  <div>Click on a minecraft name to copy to clipboard</div>
  <?
  if ($error != "")
    echo "<div class='error'>$error</div>";
  ?>
  <form action="" method="post" id="user_update_form">
    <input type="hidden" name="mode" id="submit_mode" value="add" />
    <div class="row" style="margin-top: 20px; font-weight: bold;">
      <div class="col-md-3"><a href="?sort=email" title="Sort by email">Email</a></div>
      <div class="col-md-2"><a href="?sort=role" title="Sort by role">Role</a></div>
      <div class="col-md-3"><a href="?sort=name" title="Sort by name">Minecraft Name</a></div>
      <div class="col-md-4"><a href="?sort=login" title="Sort by name">Last Login</a></div>
    </div>
<?
if (!$result)
{
?> <div><h4>An error occurred while trying to get users: <?=mysqli_error($con)?></h4></div> <?
}
else
{
  while ($row = mysqli_fetch_assoc($result))
  {
    if ($row['email'] != "")
    {
      ?>
      <div class="row" data-email="<?= $row['email'] ?>" data-minecraft-name="<?= $row['minecraft_name'] ?>" data-role="<?= $row['role'] ?>" onclick="start_update(this)" title="<?= $row['note'] ?>">
        <div class="col-md-3"><?= conceal_email($row['email']) ?></div>
        <div class="col-md-2" id="role" style="cursor: pointer;"><?= strtoupper($role->get_role_by_id($row['role'])) ?></div>
        <div class="col-md-3" data-username="<?= $row['minecraft_name'] ?>" onclick="copy_username(event);" style="cursor: pointer;"><?= ($row['minecraft_name'] != "") ? $row['minecraft_name'] : "<span style='color: orange;'>Not Entered</span>" ?></div>
        <div class="col-md-4"><?= ($row['token_expires'] != "") ? date("Y-m-d H:i", $row['token_expires'] - 60 * 60 * 24) : "<span style='color: orange;'>Never Logged In</span>" ?></div>
      </div>
      <?
    }
  }
}
?>
    <div class="row" style="margin-top: 20px;">
      <div class="three columns"><input type="email" name="email" placeholder="Email" required /></div>
      <div class="two columns">
        <select name="role" id="new_role" title="Role">
          <?
          foreach ($role::$roles as $rol)
            echo "<option value='" . $rol[0] . "' " . (($rol[0] == "vip") ? "selected" : "") . ">" . strtoupper($rol[1]) . "</option>";
          ?>
        </select>
      </div>
      <div class="three columns"><input type="text" name="note" placeholder="Note" /></div>
      <div class="four columns">
        <button class="button-primary">Add</button>
      </div>
    </div>
  </form>
</div>
<? require_once "../footer_admin.php" ?>
</body>
<script>
  var roles = JSON.parse('<?=json_encode($role::$roles)?>');
  var updating = false;

  function start_update(row)
  {
    if (!updating)
    {
      updating = true;
      let target = null;
      for (let i = 0; i < row.children.length; i++)
      {
        if (row.children[i].id == "role")
          target = row.children[i];
      }

      target.innerHTML = "";
      var input = document.createElement("select");
      input.name = "role";
      input.onchange = update_role;
      input.onblur = update_role;
      input.setAttribute("data-init-role", row.getAttribute("data-role"));
      input.setAttribute("data-email", row.getAttribute("data-email"));

      var option;
      for (let i = 0; i < roles.length; i++)
      {
        option = document.createElement("option");
        option.value = roles[i][0];
        option.innerHTML = roles[i][1];
        if (roles[i][0] == row.getAttribute("data-role"))
          option.selected = true;
        input.appendChild(option);
      }
      target.appendChild(input);
    }
  }

  function update_role(event)
  {
    var role = event.target.value;
    if (role == event.target.getAttribute("data-init-role"))
    {
      event.target.parentElement.innerHTML = role.toLocaleUpperCase();
      console.log("Same role");
    }
    else
    {
      document.getElementById("submit_mode").value = event.target.getAttribute("data-email");
      document.getElementById("new_role").setAttribute("disabled", "true");
      document.getElementById("user_update_form").submit();
      console.log("New role!");
    }
    updating = false;
  }

  function copy_username(event)
  {
    event.stopPropagation();

    event.target.style.position = "relative";
    var div = document.createElement("div");
    div.className = "float_up";
    div.innerHTML = "Username Copied";
    event.target.appendChild(div);

    var copy_me = document.createElement("textarea");
    copy_me.style.position = "fixed";
    copy_me.textContent = event.target.getAttribute("data-username");
    document.body.appendChild(copy_me);
    copy_me.select();
    document.execCommand("copy");
    document.body.removeChild(copy_me);
  }
</script>
</html>