<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>API Changelog</title>
  <link rel='stylesheet' href='//towerofawesome.org/libraries_css/normalize.css'/>
  <link rel='stylesheet' href='//towerofawesome.org/libraries_css/skeleton.css'/>
  <link rel='stylesheet' href='../assets/styles.css'/>
  <style>
    li:hover
    {
      background-color: rgba(9,9,9,.5);
    }
  </style>
</head>
<body>
<?
$changelog = array(
  "v1" => array(
    "Ditched the old api_version system",
    "Implemented folder based API versions (<code>api/v1/endpoint</code>)",
    "Updated API documentation to display api sub-folders appropriately",
  ),
  "1.0.4" => array(
    "Remove old token verifying code from get_file",
    "Fix get_download_url returning internal error instead of POST required error",
    "Make get_download_url always return internal error code in data field instead of sometimes code, sometimes message",
  ),
  "1.0.3" => array(
    "Fix API not returning version",
  ),
  "1.0.2" => array(
    "Add new error for invalid token",
    "Majorly overhaul internal error handling",
    "Fix a couple of mixed-up error codes",
    "Standardize id, secret and token verification (get rid of duplicated code)",
  ),
  "1.0.1" => array(
    "Fix <code>api/current_tag</code> returning a 500 error",
    "Allow <code>api/version</code> to accept non-local requests",
  ),
  "1.0" => array(
    "Changed <code>api/current</code> to <code>api/current_tag</code>",
    "Added <code>api/version</code>",
    "Added changelog",
    "Added general info",
    "Added common <code>'api_version'</code> field",
    "Unify error codes/messages across endpoints",
  )
);
?>
<div class="container">
  <?
  foreach ($changelog as $version => $changes)
  {
    echo "<div class='row' style='font-size: 18pt;'>" . $version . "</div>";

    echo "<ul>";
    foreach ($changes as $change)
    {
      echo "<li>" . $change . "</li>";
    }
    echo "</ul>";
  }
  ?>
</div>
</body>
</html>