<?
header("Access-Control-Allow-Origin: *");
require_once "../../internal/inc_connect.php";
require_once "../../classes/ErrorCodes.php";
require_once "../../auth.php";
require_once "../inc_functions.php";

if ($_SERVER['REQUEST_METHOD'] != "POST")
  return_error_as_json(ErrorCodes::$POST_REQUEST_REQUIRED);
if (!isset($_POST['client_id']) && $_POST['client_id'] != "")
  return_error_as_json(ErrorCodes::$CLIENT_ID_REQUIRED);
if (!isset($_POST['client_secret']) && $_POST['client_secret'] != "")
  return_error_as_json(ErrorCodes::$CLIENT_SECRET_REQUIRED);
if (!isset($_POST['token']) && $_POST['token'] != "")
  return_error_as_json(ErrorCodes::$TOKEN_IS_REQUIRED);

$client_id = $_POST['client_id'];
$client_secret = $_POST['client_secret'];
$token = $_POST['token'];

$client_data = verify_client_id_secret($client_id, $client_secret);

if ($client_data && verify_client_token($client_data['id'], $token))
{
  $type = "all";
  if (isset($_POST['type']))
    $type = $_POST['type'];
  if ($type == "all")
    $type = "";
  else
    $type = " WHERE type = '" . $type . "'";
  $limit = "";
  if (isset($_POST['limit']))
    $limit = " LIMIT " . $_POST['limit'];
  $query = "SELECT ads.id as id, created_time, bumped, edited, type, title, body, minecraft_name, minecraft_uuid FROM ads" . $type . $limit . " INNER JOIN users ON ads.owner_email = users.email ORDER BY bumped ASC";
  $result = mysqli_query($con, $query);

  if ($result)
  {
    $data = array();
    while ($row = mysqli_fetch_assoc($result))
      $data[] = $row;

    return_success_as_json(array("ads" => $data));
  }
  else
    return_error_as_json(ErrorCodes::$SQL_ERROR, mysqli_error($con));
}
