<?
header("Access-Control-Allow-Origin: *");
require_once "../../internal/inc_connect.php";
require_once "../../classes/ErrorCodes.php";
require_once "../../inc_functions.php";
require_once "../../auth.php";
require_once "../inc_functions.php";

if ($_SERVER['REQUEST_METHOD'] != "POST")
  return_error_as_json(ErrorCodes::$POST_REQUEST_REQUIRED);
if (!isset($_POST['client_id']) || $_POST['client_id'] == "")
  return_error_as_json(ErrorCodes::$CLIENT_ID_REQUIRED);
if (!isset($_POST['client_secret']) || $_POST['client_secret'] == "")
  return_error_as_json(ErrorCodes::$CLIENT_SECRET_REQUIRED);
if (!isset($_POST['token']) || $_POST['token'] == "")
  return_error_as_json(ErrorCodes::$TOKEN_IS_REQUIRED);

$client_id = $_POST['client_id'];
$client_secret = $_POST['client_secret'];
$token = $_POST['token'];

$client_data = verify_client_id_secret($client_id, $client_secret);

$token_real = verify_client_token($client_data['id'], $token);

if ($token_real)
{
  $data = array(
    "dummy" => "dummy"
  );
  if (isset($_POST['patch_from']))
    $data['from'] = $_POST['patch_from'];
  if (isset($_POST['opt_mods']))
    $data['opt_mods'] = $_POST['opt_mods'];

  $url = $login_redirect_url . "internal/generate_archive.php";
  $data = curl_request_simple($url, $data,true);

  if ($data['result'])
  {
    $result = json_decode($data['result'], true);

    if ($result['result'] == 0 && $data['code'] == 200)
    {
      $return = array(
        "code" => $data['code'],
        "id" => $result['id'],
        "filename" => $result['filename'],
        "is_patch" => $result['is_patch'],
        "size_raw" => $result['size_raw'],
        "size" => $result['size'],
        "mod_count" => $result['count_mods'],
        "mod_count_opt" => $result['count_mods_opt'],
        "res_count" => $result['count_resources']
      );
      return_success_as_json($return);
    }
    else
      return_error_as_json(ErrorCodes::$INTERNAL_ERROR, array("code" => $data['code'], "result" => $result['result'], "msg" => $result['msg']));
  }
  else
    return_error_as_json(ErrorCodes::$INTERNAL_ERROR, $data["code"]);
}
echo "You shouldn't be able to see this... (get_download_url endpoint ended without returning anything)";
