<?
//Created 26/12/2017

?>
<!DOCTYPE html>
<html lang="en">
<head>
  <title>ForeModpacker</title>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <script src="//towerofawesome.org/libraries_javascript/jquery.min.js"></script>
  <style>
    body {
      background-color: #161616;
      color: white;
    }

    .success {
      background-color: green;
    }

    .error {
      background-color: red;
    }
  </style>
</head>
<body>
<h2>API Client Flow Test</h2>
<button onclick="run_test()">Run Test</button>
<div id="output">

</div>
<script>
//  var my_client_id = "59170fb0d2a5a";
//  var my_secret = "5885463a6f1309b2987de71a1f58f5db46e043538e692aa467749db4a6d115ca";
  var my_client_id = "5936fb3c5a20c";
  var my_secret = "bc657f236f41824002aba09775d9c66ddbacbe3ce5e983e5bf58f652c10ab35f";

  var base_url = "https://towerofawesome.org/railcraftpack/api/v1/";
  var output = document.getElementById("output");

  function escapeHtml(unsafe)
  {
    return unsafe
      .replace(/&/g, "&amp;")
      .replace(/</g, "&lt;")
      .replace(/>/g, "&gt;")
      .replace(/"/g, "&quot;")
      .replace(/'/g, "&#039;");
  }

  function clear()
  {
    output.innerHTML = "";
  }

  function log(msg, level)
  {
    if (typeof level == "undefined")
      level = "error";
    output.innerHTML += "<div class='" + level + "'>" + escapeHtml(msg) + "</div>";
  }

  function run_test()
  {
    clear();

    current_tag();
  }

  function parse_json(json)
  {
    console.info(json);
    try {
      return JSON.parse(json);
    }
    catch (e)
    {
      console.info(json);
      console.error(e);
      log("Failed to parse json");
      return null;
    }
  }

  function current_tag()
  {
    $.post(base_url + "current_tag")
      .done(function(payload)
      {
        log("'current_tag' => Request success: " + payload, "success");
        payload = parse_json(payload);
        if (payload == null)
        {
          log("'current_tag' => Error: JSON parse failed");
          return;
        }
        if (payload.result !== 0)
        {
          log("'current_tag' => Error: " + payload['msg']);
          return;
        }
        log("'current_tag' => Calling Next Endpoint 'auth'", "success");
        auth(my_client_id, my_secret);
      })
      .fail(function(payload)
      {
        log("'current_tag' => Request failure: " + payload.status);
      })
  }

  function auth(client_id, client_secret)
  {
    $.post(base_url + "auth", { client_id: client_id, client_secret: client_secret })
      .done(function(payload)
      {
        log("'auth' => Request success: " + payload, "success");
        payload = parse_json(payload);
        if (payload == null)
        {
          log("'auth' => Error: JSON parse failed");
          return;
        }
        if (payload.result !== 0)
        {
          log("'auth' => Error: " + payload['msg']);
          return;
        }
        log("'auth' => Calling Next Endpoint 'get_download_url'", "success");
        get_download_url(client_id, client_secret, payload.token);
      })
      .fail(function(payload)
      {
        log("'auth' => Request failure: " + payload.status);
      })
  }

  function get_download_url(client_id, client_secret, token)
  {
    $.post(base_url + "get_download_url", { client_id: client_id, client_secret: client_secret, token: token })
      .done(function(payload)
      {
        log("'get_download_url' => Request success: " + payload, "success");
        payload = parse_json(payload);
        if (payload == null)
        {
          log("'get_download_url' => Error: JSON parse failed");
          return;
        }
        if (payload.result !== 0)
        {
          log("'get_download_url' => Error: " + payload['msg']);
          return;
        }
        // log("'get_download_url' => Calling Next Endpoint 'get_file'", "success");
        // get_file(client_id, client_secret, token, payload.id);
      })
      .fail(function(payload)
      {
        log("'get_download_url' => Request failure: " + payload.status);
      })
  }

  function get_file(client_id, client_secret, token, id)
  {
    $.post(base_url + "get_file", { client_id: client_id, client_secret: client_secret, token: token, id: id })
      .done(function(payload)
      {
        console.info(typeof payload);
        console.info(payload);
        log("'get_file' => Request success: " + payload, "success");
        payload = parse_json(payload);
        if (payload == null)
        {
          log("'get_file' => Error: JSON parse failed");
          return;
        }
        if (payload.result !== 0)
        {
          log("'get_file' => Error: " + payload['msg']);
          return;
        }
      })
      .fail(function(payload)
      {
        log("'get_file' => Request failure: " + payload.status);
      })
  }
</script>
</body>
</html>