<?
//Created 17/04/2017
require_once "inc_functions.php";
require_once "inc_common_functions.php";
require_once "internal/inc_connect.php";
require_once "classes/SimpleSetting.php";
require_once "krumo/class.krumo.php";

$simpleSettings = new SimpleSetting();

$untagged = "";
if (isset($_GET['untagged']) && $_GET['untagged'] == "true")
  $untagged = " AND (release_tag IS NULL OR release_tag = '')";

$result = mysqli_query($con, "SELECT * FROM files WHERE update_id IS NOT NULL AND update_id != '' $untagged ORDER BY update_time DESC");

$hourly = false;
if (isset($_GET['hourly']) && $_GET['hourly'] == "true")
  $hourly = true;

?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Changelog - <?= $simpleSettings->Load(SimpleSetting::$PAGE_TITLE)->value ?></title>
  <link rel='stylesheet' href='assets/bootstrap.min.css' />
  <script src='assets/bootstrap.min.js'></script>
  <script src='assets/cookie_functions.min.js'></script>
  <link rel='stylesheet' href='assets/styles.css' />
  <style>
    .mod_row
    {
      background-color: #424242;
    }

    .mod_row:nth-child(2n+1)
    {
      background-color: #4b4b4b;
    }

    .mod_row:hover
    {
      background-color: #3c3f41;
    }

    .removed
    {
      color: orangered;
    }

    .new
    {
      color: lightgreen;
    }

    .sub_files_change
    {
      color: darkorange;
    }
  </style>
</head>
<body style="padding: 16px;">
<div>
  <?
//  $menu = array(
//    "Back" => array("type" => "link", "url" => "."),
//    "Mode" => array(
//      "type" => "menu",
//      "items" => array(
//        "Daily" => array("type" => "link", "url" => "./changelog?hourly=false"),
//        "Hourly" => array("type" => "link", "url" => "./changelog?hourly=true"),
//      )
//    ),
//    "Changes" => array(
//      "type" => "menu",
//      "items" => array(
//        "Show All" => array("type" => "link", "url" => "./changelog?untagged=false"),
//        "Show Untagged" => array("type" => "link", "url" => "./changelog?untagged=true")
//      )
//    ),
//  );
//
//
//
//  build_menu();
  $menu = get_default_menu();
  $menu->AddLink(new MenuLink("Back", "."), true);
  echo $menu->BuildMenu();
  ?>
</div>
<div class="container-flex">
  <?
  $current_date = null;
  $current_tag = null;
  if (!$result)
  {
    echo "SQL Error";
    echo "<br/><span style='color: white;'>" . mysqli_error($con) . "</span>";
  }
  elseif (mysqli_num_rows($result) > 0)
  {
    while ($mod = mysqli_fetch_assoc($result))
    {
      $this_date = date((($hourly) ? "Y-m-d H:00" : "Y-m-d"), $mod['update_time']);
      $this_tag = $mod['release_tag'];
      $row_content = "";
      if ($current_date == null || $current_date != $this_date)
      {
        $row_content .= "<span style='font-size: 18pt;'>$this_date</span>";
        $current_date = $this_date;
      }
      if ($this_tag != "" && ($current_tag == null || $current_tag != $this_tag))
      {
        $row_content .= " <span style='font-size: 14pt; color: slategray;'>$this_tag</span>";
        $current_tag = $mod['release_tag'];
      }
      if ($row_content != "")
        echo "<div class='row' style='margin-top: 10px;'><div class='col-md-10'>$row_content</div></div>";
      $class = "";
      $note = "";
      if ($mod['version_from'] == "new")
        $class = "new";
      elseif ($mod['version_to'] == "removed")
        $class = "removed";
      elseif ($mod['version_to'] == $mod['version_from'])
      {
        $class = "sub_files_change";
        $note = " (Sub-file change or updated fields)";
      }
      echo insert("
  <div class='row mod_row $class'>
    <div class='col-md-3'>{mod_name}</div>
    <div class='col-md-5'>{version_from} => {version_to}<dim>{note}</dim></div>
    <div class='col-md-3'>{update_reason}</div>
  </div>", array(
        "mod_name" => $mod['mod_name'],
        "version_from" => $mod['version_from'],
        "version_to" => $mod['version_to'],
        "note" => $note,
        "update_reason" => ($mod['version_from'] == "new") ? "NEW" : $mod['update_reason']
      ));
    }
  }
  else
    echo "No entries found";
  ?>
</div>
  <? include_once "footer.php"; ?>
</body>
</html>