<?


namespace Patreon;

/**
 * Class FileType
 * @package Patreon
 * @property string $MOD
 * @property string $CONFIG
 * @property string $RESOURCE
 * @property string $LIBRARY
 */
class FileType
{
  public static $MOD = "mod";
  public static $CONFIG = "config";
  public static $RESOURCE = "resource";
  public static $LIBRARY = "library";
}

/**
 * Class File
 * @package Patreon
 * @property int $id
 * @property string $mod_name
 * @property string $mod_id
 * @property string $system_file_name
 * @property string $filename
 * @property string $parent_identifier
 * @property string $file_type
 * @property string $path
 * @property string $update_id
 * @property int $update_time
 * @property string $version_from
 * @property string $version_to
 * @property bool $is_required
 * @property int $pack_side
 * @property string $other_dependencies
 * @property bool $default_selected
 * @property string $update_reason
 * @property string $release_tag
 * @property string $description
 */
class File
{
  public $id;
  public $mod_name;
  public $mod_id;
  public $system_file_name;
  public $filename;
  public $parent_identifier;
  public $file_type;
  public $path;
  public $update_id;
  public $update_time;
  public $version_from;
  public $version_to;
  public $is_required;
  public $pack_side;
  public $other_dependencies;
  public $default_selected;
  public $update_reason;
  public $release_tag;
  public $description;

  /**
   * File constructor.
   * @param int $id
   * @param string $mod_name
   * @param string $mod_id
   * @param string $system_file_name
   * @param string $filename
   * @param string $parent_identifier
   * @param string $file_type
   * @param string $path
   * @param string $update_id
   * @param int $update_time
   * @param string $version_from
   * @param string $version_to
   * @param bool $is_required
   * @param int $pack_side
   * @param string $other_dependencies
   * @param bool $default_selected
   * @param string $update_reason
   * @param string $release_tag
   * @param string $description
   */
  public function __construct($id = null, $mod_name = null, $mod_id = null, $system_file_name = null, $filename = null, $parent_identifier = null, $file_type = null, $path = null, $update_id = null, $update_time = null, $version_from = null, $version_to = null, $is_required = null, $pack_side = null, $other_dependencies = null, $default_selected = null, $update_reason = null, $release_tag = null, $description = null)
  {
    $this->id = $id;
    $this->mod_name = $mod_name;
    $this->mod_id = $mod_id;
    $this->system_file_name = $system_file_name;
    $this->filename = $filename;
    $this->parent_identifier = $parent_identifier;
    $this->file_type = $file_type;
    $this->path = $path;
    $this->update_id = $update_id;
    $this->update_time = $update_time;
    $this->version_from = $version_from;
    $this->version_to = $version_to;
    $this->is_required = $is_required;
    $this->pack_side = $pack_side;
    $this->other_dependencies = $other_dependencies;
    $this->default_selected = $default_selected;
    $this->update_reason = $update_reason;
    $this->release_tag = $release_tag;
    $this->description = $description;
  }

  public function Load()
  {
    global $con;
    require_once __DIR__ . "/../internal/inc_connect.php";
    $query = null;
    if (isset($this->id))
      $query = "SELECT * FROM files WHERE id = '" . $this->id . "'";
    elseif (isset($this->mod_id))
      $query = "SELECT * FROM files WHERE mod_id = '" . $this->mod_id . "'";

    if (isset($query))
    {
      $result = mysqli_query($con, $query);

      if ($result)
      {
        $row = mysqli_fetch_assoc($result);
        foreach ($this as $property => $value)
        {
          if (isset($row[$property]))
            $this[$property] = $row[$property];
        }
      }
    }
    return $this;
  }
}