<?

class OldMenu
{
  public static $LEVEL_MOD = "mod";
  public static $LEVEL_ADMIN = "admin";
  public static $ALIGN_RIGHT = "right";
  public $menu;

  public function __construct($menu = array())
  {
    $this->menu = $menu;
  }

  public function AddSubmenu($title, $items = array(), $level = null)
  {
    $it = array();
    $it['type'] = "menu";
    $it['items'] = $items;
    if (isset($level))
      $it['level'] = $level;
    $menu = array(
      $title => $it
    );
    $this->menu = array_merge($this->menu, $menu);
  }

  public function AddSubmenuLink($submenu_title, $title, $url, $hover_title = null, $level = null)
  {
    $it = array();
    $it['type'] = "link";
    $it['url'] = $url;
    if (isset($hover_title))
      $it['title'] = $hover_title;
    if (isset($level))
      $it['level'] = $level;
    $item = array(
      $title => $it
    );
    if (isset($this->menu[$submenu_title]))
      $this->menu[$submenu_title]['items'] = array_merge($this->menu[$submenu_title]['items'], $item);
  }

  public function AddSubmenuSpacer($submenu_title, $title = "")
  {
    $item = array(
      $title => array(
        "type" => "spacer"
      )
    );
    if (isset($this->menu[$submenu_title]))
      $this->menu[$submenu_title]['items'] = array_merge($this->menu[$submenu_title]['items'], $item);
  }

  public function AddSubmenuButton($submenu_title, $title, $function, $hover_title = null, $level = null)
  {
    $it = array();
    $it['type'] = "button";
    $it['func'] = $function;
    if (isset($hover_title))
      $it['title'] = $hover_title;
    if (isset($level))
      $it['level'] = $level;
    $item = array(
      $title => $it
    );
    if (isset($this->menu[$submenu_title]))
      $this->menu[$submenu_title]['items'] = array_merge($this->menu[$submenu_title]['items'], $item);
  }

  public function AddLink($title, $url, $hover_title = null, $level = null, $align = null)
  {
    $it = array();
    $it['type'] = "link";
    $it['url'] = $url;
    if (isset($hover_title))
      $it['title'] = $hover_title;
    if (isset($level))
      $it['level'] = $level;
    if (isset($align))
      $it['align'] = $align;
    $link = array(
      $title => $it
    );
    $this->menu = array_merge($this->menu, $link);
  }

  public function AddButton($title, $function, $hover_title = null, $level = null)
  {
    $it = array();
    $it['type'] = "button";
    $it['func'] = $function;
    if (isset($hover_title))
      $it['title'] = $hover_title;
    if (isset($level))
      $it['level'] = $level;
    $link = array(
      $title => $it
    );
    $this->menu = array_merge($this->menu, $link);
  }

  /**
   * Menu constructing function
   * $menu = array(
   *  "Item Name" => array(
   *    "type" => menu|link,
   *    "items" => array(
   *      array("type" => link|spacer, "url" => "http://foo.bar")
   *    )
   *  )
   * )
   */
  function BuildMenu()
  {
    $menu = $this->menu;
    global $session;

    function parse_item($label, $item, $item_class = "sub_menu_item")
    {
      global $session;
      if (isset($item['level']) && !role_has_access($session, $item['level']))
        return;
      if ($item['type'] == "spacer")
      {
        echo "<div class=\"menu_spacer\">$label</div>";
      }
      elseif ($item['type'] == "link")
      {
        $url = $item['url'];
        $title = "";
        if (isset($item['title']))
          $title = "title = '" . str_replace("'", "&#39;", str_replace("\"", "&#34;", $item['title'])) . "'";
        $align = "";
        if (isset($item['align']))
          $align = "style=\"float: " . $item['align'] . ";\"";
        echo "<a href=\"$url\" $align><div class=\"$item_class\" $title>$label</div></a>";
      }
      elseif ($item['type'] == "button")
      {
        $onclick = $item['func'];
        echo "<div class=\"$item_class\" onclick=\"$onclick\">$label</div>";
      }
      elseif ($item['type'] == "menu")
      {
        if (isset($item['items']))
        {
          echo "<div class=\"sub_menu\">";
          foreach ($item['items'] as $label => $sub_item)
            parse_item($label, $sub_item);
          echo "</div>";
        }
        else
          echo "<div style='color: red;'>Something went wrong parsing the menu!</div>";
      }
    }

    if (isset($menu) && is_array($menu) && count($menu) > 0)
    {
      echo "<div class=\"menu_bar_spacer\"></div>";
      echo "<div class=\"menu_bar\" style=\"z-index: 1000;\">";
      foreach ($menu as $label => $item)
      {
        if (isset($item['level']) && !role_has_access($session, $item['level']))
          continue;
        if ($item['type'] == "menu")
        {
          if (isset($item['items']))
          {
            $length = strlen($label);
            foreach ($item['items'] as $labellabel => $itemitem)
              $length = max($length, strlen($labellabel));
            $width = $length * 0.60 . "em"; //This makes the base menu item wide enough to fit the longest sub-item

            echo "<div class=\"menu_item\" style=\"text-decoration: none; width: $width\">";
            echo $label;
            parse_item($label, $item);
            echo "</div>";
          }
          else
            echo "<div style='color: red;'>Something went wrong parsing the menu!</div>";
        }
        else
          parse_item($label, $item, "menu_item");
      }
      echo "</div>";
    }
  }
}