<?
//Created 14/06/2017
require_once "inc_functions.php";
require_once "krumo/class.krumo.php";
require_once "constants.php";

list($session, $email) = get_login_session();

if (isset($_POST['title']))
{
  $title = $_POST['title'];
  $type = $_POST['ad_type'];
  $body = $_POST['body_text'];

  $result = ad_new($email, $type, $title, $body);

  list($result, $error, $msg, $data) = parse_json_return($result);

  if ($result)
    header("Location: classifieds_list");
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Classifieds - ForeModpacker</title>
  <link rel="stylesheet" href="//towerofawesome.org/libraries_css/normalize.css" />
  <link rel="stylesheet" href="//towerofawesome.org/libraries_css/skeleton.css" />
  <link rel="stylesheet" href="assets/styles.css"/>
  <link rel="stylesheet" href="assets/style_newspaper.css"/>
  <style>
    input[type=text], input[type=text]:focus
    {
      font-family      : 'Playfair Display', serif;
      background-color : transparent;
      border           : 0;
      border-bottom    : 1px dotted #2f2f2f;
      border-radius    : 0;
    }

    textarea, textarea:focus
    {
      background-color : transparent;
      border           : 0;
    }
  </style>
</head>
<body>
<div class="container">
<?
if (isset($msg) && $msg != "")
{
  ?>
  <div class="error"><?=$msg . ((isset($data)) ? " (".$data.")" : "")?></div>
  <?
}
?>
  <form action="" method="post">
  <div class="container" style="width: 250px; border: 1px dashed #2f2f2f; padding: 10px; margin-top: 10px;">
    <div><input type="text" name="title" title="Title" placeholder="Title" /></div>
    <div>
      <div class="pnt" style="display: inline-block;">
        <label style="position: relative;" onclick="toggle_icon(event)">
          <span class="button_checked" style="width: 25px; height: 25px; position: relative; top: 8px;" onclick="toggle_icon(event)">
            <input type="radio" style="display: none;" name="ad_type" value="sell" checked/>
          </span>
          Sell
        </label>
      </div>
      <div class="pnt" style="display: inline-block;">
        <label style="position: relative;" onclick="toggle_icon(event)">
          <span class="button_unchecked" style="width: 25px; height: 25px; position: relative; top: 8px;" onclick="toggle_icon(event)">
            <input type="radio" style="display: none;" name="ad_type" value="buy"/>
          </span>
          Buy
        </label>
      </div>
    </div>
    <div><textarea name="body_text" title="Body" placeholder="Write your ad here" style="resize: none; height: 160px;" onkeyup="on_text_update(event)"></textarea></div>
    <div id="words">70 words left</div>
    <div><button>Submit</button></div>
  </div>
  </form>
  <div>
    <p>You can put an image in the ad by putting a <b>direct</b> link to it in the body! Supported image types are png, jpg, jpeg & gif.</p>
    <p>The image preview is automatically displayed in sepia (if the viewers browser supports it). Clicking the image will show it in full size and without the sepia effect.</p>
    <p>You can host images on for example <a href="http://imgur.com">imgur.com</a></p> or any other service where you can get a permanent direct link to it.
  </div>
</div>
</body>
<script>
  function on_text_update(event)
  {
    if (event.target.value == "")
      document.getElementById("words").innerHTML = "70 words left";
    else
    {
      var words = event.target.value.split(" ");
      var calc = 70 - words.length;
      var text = "";
      if (calc < 0)
        text = "<span style='color: red'>Too many words! (" + calc * -1 + ")</span>";
      else
        text = calc + " words left";
      document.getElementById("words").innerHTML = text;
    }
  }

  function toggle_icon(event)
  {
    var off_class = "button_unchecked";
    var on_class = "button_checked";

    var target = event.target;
    if (target.className != off_class && target.className != on_class)
      target = target.children[0];
    if (typeof target == "undefined")
      return;
    if (target.className != off_class && target.className != on_class)
      target = target.children[0];
    var elements = document.getElementsByName(target.children[0].name);
    for (let i = 0; i < elements.length; i++)
      elements[i].parentElement.className = off_class;
    target.className = on_class;
    event.stopPropagation();
  }
</script>
</html>