<?
//Created 2016-03-29
use Patreon\SettingString;
use Patreon\SettingSwitch;

require_once "internal/inc_connect.php";
require_once "inc_common_functions.php";
require_once "inc_functions.php";
require_once "krumo/class.krumo.php";
require_once "classes/SimpleSetting.php";
require_once "classes/Setting.php";

debug_init();

$simpleSettings = new SimpleSetting();
$error = 0;
$optional_mods = 0;
$resource_count = 0;
$tag = get_latest_tag($dev_mode, true);

$mod_entity = "
  <div class='mod_entity row'>
    <div class='col-md-1' style='text-align: right;'>
      {toggle}
    </div>
    <div class='col-md-11'>
      <div><b>{name}</b> - {version} {description}</div>
      <div style='display: none'>{more_info}</div>
      <div onclick='more_info_show(event);' class='moinfo'>Show {file_count} File{s}</div>
    </div>
  </div>";

$query = "SELECT * FROM files WHERE file_type = 'mod' && release_tag IS NOT NULL && release_tag != '' ORDER BY update_time ASC";
$result = mysqli_query($con, $query);
$files = array();
if ($result && mysqli_num_rows($result) > 0)
{
  while ($row = mysqli_fetch_assoc($result))
  {
    $files[$row['mod_id']] = $row;
    if ($row['is_required'] == false)
      $optional_mods++;
  }

  $files = array_order_by($files, "mod_name", SORT_ASC);
}
else
  $error = 1;

$query = "SELECT * FROM files WHERE file_type = 'resource' && release_tag IS NOT NULL && release_tag != '' ORDER BY update_time ASC";
$result = mysqli_query($con, $query);
$resources = array();
if ($result && mysqli_num_rows($result) > 0)
{
  while ($row = mysqli_fetch_assoc($result))
  {
    $resources[$row['mod_id']] = $row;
    $resource_count++;
  }

  $resources = array_order_by($resources, "mod_name", SORT_ASC);
}
else
  $error = 2;

/** @var SettingSwitch $page_title */
$page_title = $simpleSettings->Load(SimpleSetting::$PAGE_TITLE);
/** @var SettingSwitch $whitelist_update */
$whitelist_update = $simpleSettings->Load(SimpleSetting::$WHITELIST_UPDATE);
/** @var SettingSwitch $public_mod_list */
$public_mod_list = $simpleSettings->Load(SimpleSetting::$PUBLIC_MOD_LIST_ENABLED);
/** @var SettingString $forge_version */
$forge_version = $simpleSettings->Load(SimpleSetting::$FORGE_VERSION);
/** @var SettingSwitch $downloads_enabled */
$downloads_enabled = $simpleSettings->Load(SimpleSetting::$DOWNLOADS_ENABLED);
?>
<head>
  <meta charset="UTF-8">
  <title>ForeModpacker - <?= $page_title->Value() ?></title>
  <link rel='stylesheet' href='assets/bootstrap.min.css' />
  <script src='assets/bootstrap.min.js'></script>
  <script src='assets/cookie_functions.min.js'></script>
  <link rel="stylesheet" href="assets/styles.css" />
  <script src="//towerofawesome.org/libraries_javascript/jquery.min.js"></script>
  <script src="internal/functions.js"></script>
  <style>
    .mod_entity:nth-child(2n+1)
    {
      background-color: #4c4c4c;
    }

    .moinfo
    {
      cursor    : pointer;
      color     : dimgray;
      font-size : 10pt;
    }

    div.row > div
    {
      padding-left: 6px;
    }

    r {
      color: red;
    }
  </style>
</head>
<body>
<div class="new_user_popup" id="new_user_popup" style="display: none;">
  <div>
    Hi, we don't know you <?=$email?>!<br/>
    Please tell us about yourself:
  </div>
  <div>
    <input class="form-control" type="text" id="minecraft_name" placeholder="Minecraft Name"/>
  </div>
  <div>We need to know your username and UUID for the whitelist (UUID is fetched automatically)</div>
  <? if ($whitelist_update->TestEnabled()) { ?><div style="color: #ff9e1f;">If you are unable to join after submitting please contact us.</div><? } ?>
  <? if ($whitelist_update->TestDisabled()) { ?><div style="color: #ff9e1f;">The whitelist is currently not updated automatically! Contact us to be whitelisted!</div><? } ?>
  <div id="new_user_error_output"></div>
  <div style="text-align: center; margin-top: 10px;">
    <button class="btn btn-primary" onclick="register_username()">Submit</button>
  </div>
  <div style="text-align: center;"><span onclick="hide_new_user_popup(); overlay_off();" class="pnt">Do this later</span></div>
</div>
<div>
  <?
  $menu_root = "";
  $menu = get_default_menu();
  echo $menu->BuildMenu();

  ?>
</div>
<div class="container">
  <div class="major-header"><?= $page_title->Value() ?></div>
  <? require_once "overlay_spinner.html" ?>
  <div style="margin-bottom: 10px;"><h4>Welcome <span id="greeting_minecraft_name">User</span>!</h4></div>
  <div style="margin-bottom: 10px;">The server address is <input type="text" class="display_input" title="Server address" value="officialrailcraft.g.akliz.net" readonly onclick="this.select()" /></div>
  <div style="margin-bottom: 10px;">
    <div style="display: inline-block; font-size: 2rem; position: relative;">Current Forge:
      <div class="button_about" style="position: absolute; top: -14px; right: -22px;" onclick="info_button_toggle(this);">
        <div class="info_bubble" style="display: none;">
          This is the Forge version used on the server. You need to install the mods from the download below into an instance with this version of Forge installed to be able to join the server.
        </div>
      </div>
    </div>
    <span style="font-size: 2rem;"><dim><?= $forge_version->Value() ?></dim></span>
  </div>
  <div style="margin-bottom: 10px;">
    <div style="display: inline-block; font-size: 2rem; position: relative;">Current Tag:
      <div class="button_about" style="position: absolute; top: -14px; right: -22px;" onclick="info_button_toggle(this);">
        <div class="info_bubble" style="display: none;">
          A "tag" represents an update of the modpack and will usually be a version number. When the tag changes, the modpack has been updated and you'll need to re-download to be able to connect to the server.
        </div>
      </div>
    </div>
    <span style="font-size: 2rem;"><dim><?=$tag?></dim></span>
  </div>
<!--  <div style="margin-bottom: 20px">-->
<!--    <div><b>Ways to get notified of updates:</b></div>-->
<!--    <div><a href="https://www.pushbullet.com/channel?tag=officialrailcraftpack" target="_blank">Follow on Pushbullet</a> for browser/mobile push notifications.</div>-->
<!--    <div><a href="rss_2.xml" target="_blank">Follow via RSS</a></div>-->
<!--    <div><dim>Suggest more services by contacting us! (See bottom of page)</dim></div>-->
<!--  </div>-->
<!--  <div style="margin-bottom: 20px">-->
<!--    <div><b>Other info:</b></div>-->
<!--    <div><a href=https://discord.gg/xRk8MnD target="_blank">Discord Server</a></div>-->
<!--    <div><a href="scoreboards.html" target="_blank">Scoreboards</a></div>-->
<!--    <div><a href="api/" target="_blank">Public API Documentation</a></div>-->
<!--  </div>-->
  <div>
    <? if ($downloads_enabled->TestEnabled()) { ?>
    <button id="pack_download_button" style="width: 180px;" class="btn btn-success" onclick="request_generation();" >Get Download</button>
    <div class="pnt" style="display: inline-block;">
      <label style="position: relative;" onclick="toggle_icon(event)">
        <span class="button_ok off" style="width: 45px; height: 45px; position: relative; top: 16px;" onclick="toggle_icon(event)">
          <input type="checkbox" style="display: none;" id="get_patch_checkbox" onchange="patch_checkbox_change(event);" />
        </span>
        Only changed files
      </label>
    </div>
    <? }
       else
       { ?>
    <div>
      <h4><b><r>Downloads are temporarily unavailable!<br/>
            Please check back later!</r></b></h4>
      <button class="btn btn-dark" disabled >UNAVAILABLE</button>
    </div>
    <? } ?>
  </div>
  <div>Want the pack to update automatically? Check out the available updaters under Extras in the menu!</div>
  <div class="space"></div>
  <div id="more_dl_options" style="display: none;">
    <div><div style="display: inline-block; position: relative;"><label for="from_tag">Get patch archive from [Tag] to current </label>
      <div class="button_about" style="position: absolute; top: -14px; right: -28px;" onclick="info_button_toggle(this);">
        <div class="info_bubble" style="display: none;">
          A patch archive will only contain files that have been added or updated since the selected tag.<br/><br/>Additionally files that were removed will be replaced with an empty file so you don't have to remove old versions manually. Just overwrite all when extracting.<br/><br/>Open the pack.version file included with the last pack you downloaded to find out which version you are on currently!
        </div>
      </div></div>
      <span><select id="from_tag" class="form-control">
          <option value="null">Tag</option>
          <?
          $result = mysqli_query($con, "SELECT * FROM tags ORDER BY id DESC");
          if ($result)
          {
            $row = mysqli_fetch_assoc($result);
            while ($row = mysqli_fetch_assoc($result))
              echo "<option value='" . $row['tag'] . "'>" . $row['tag'] . "</option>";
          }
          ?>
        </select></span></div>
  </div>
  <div class="container">
  <?
  if ($optional_mods > 0)
  {
    echo "<div><h5>Optional Mods</h5></div>";
    foreach ($files as $file)
    {
      if ($file['is_required'] == false && $file['version_to'] != "removed" && ($file['pack_side'] == 1 || $file['pack_side'] == 2))
      {
        $query = "SELECT * FROM files WHERE parent_identifier = '".$file['update_id']."'";
        $result = mysqli_query($con, $query);
        $sub_files = "<div><dim>".$file['path']."</dim>".$file['filename']."</div>";
        $counter = 1;
        if ($result && mysqli_num_rows($result) > 0)
        {
          while ($row = mysqli_fetch_assoc($result))
          {
            $counter++;
            $sub_files .= "<div style='text-indent: 10px;'><dim>" . $row['path'] . "</dim>" . $row['filename'] . "</div>";
          }
        }

        echo insert($mod_entity, array(
          "name" => $file['mod_name'],
          "version" => $file['version_to'] . " <dim>(" . $file['mod_id'] . ")</dim>",
          "filename" => $file['filename'],
          "toggle" => "<span class='button_ok ".(($file['default_selected']) ? "" : "off")."' onclick='toggle_checkbox(event);'><input class='optional_mods' type='checkbox' value='".$file['mod_id']."' style='display: none;' ".(($file['default_selected']) ? "checked" : "")." /></span>",
          "description" => ((isset($file['description']) && $file['description'] != "") ? "<dim> - " . $file['description'] . "</dim>" : ""),
          "more_info" => $sub_files,
          "file_count" => $counter,
          "s" => ($counter > 1) ? "s" : ""
        ));
      }
    }
  }
  ?>
  <?
  if ($resource_count > 0)
  {
    echo "<div style='margin-top: 20px;'><h5>Resource Packs</h5></div>";
    foreach ($resources as $resource)
    {
      if ($resource['version_to'] != "removed" && ($resource['pack_side'] == 1 || $resource['pack_side'] == 2))
      {
        $query = "SELECT * FROM files WHERE parent_identifier = '".$resource['update_id']."'";
        $result = mysqli_query($con, $query);
        $sub_resources = "<div><dim>".$resource['path']."</dim>".$resource['filename']."</div>";
        $counter = 1;
        if ($result && mysqli_num_rows($result) > 0)
        {
          while ($row = mysqli_fetch_assoc($result))
          {
            $counter++;
            $sub_resources .= "<div style='text-indent: 10px;'><dim>" . $row['path'] . "</dim>" . $row['filename'] . "</div>";
          }
        }
        if ($resource['is_required'] == true)
          $toggle = "";
        else
          $toggle = "<span class='button_ok ".(($resource['default_selected']) ? "" : "off")."' onclick='toggle_checkbox(event);'><input class='optional_mods' type='checkbox' value='".$resource['mod_id']."' style='display: none;' ".(($resource['default_selected']) ? "checked" : "")." /></span>";

        echo insert($mod_entity, array(
          "name" => $resource['mod_name'],
          "version" => $resource['version_to'],
          "filename" => $resource['filename'],
          "toggle" => $toggle,
          "description" => ((isset($resource['description']) && $resource['description'] != "") ? "<dim> - " . $resource['description'] . "</dim>" : ""),
          "more_info" => $sub_resources,
          "file_count" => $counter,
          "s" => ($counter > 1) ? "s" : ""
        ));
      }
    }
  }
  ?>
  <div style="margin-top: 20px;"><h5>Server Only Mods <dim>(Not included)</dim></h5></div>
  <?
  $server_mod_counter = 0;
  foreach ($files as $file)
  {
    if ($file['version_to'] != "removed" && $file['pack_side'] == 0)
    {
      $server_mod_counter++;
      $query = "SELECT * FROM files WHERE parent_identifier = '".$file['update_id']."'";
      $result = mysqli_query($con, $query);
      $sub_files = "<div><dim>".$file['path']."</dim>".$file['filename']."</div>";
      $counter = 1;
      if ($result && mysqli_num_rows($result) > 0)
      {
        while ($row = mysqli_fetch_assoc($result))
        {
          $counter++;
          $sub_files .= "<div style='text-indent: 10px;'><dim>" . $row['path'] . "</dim>" . $row['filename'] . "</div>";
        }
      }
      echo insert($mod_entity, array(
        "name" => $file['mod_name'],
        "version" => $file['version_to'],
        "filename" => $file['filename'],
        "toggle" => "",
        "description" => ((isset($file['description']) && $file['description'] != "") ? "<dim> - " . $file['description'] . "</dim>" : ""),
        "more_info" => $sub_files,
        "file_count" => $counter,
        "s" => ($counter > 1) ? "s" : ""
      ));
    }
  }
  if ($server_mod_counter == 0)
    echo "<div>No mods to list</div>";
  ?>
  <div style="margin-top: 20px;"><h5>Required Mods</h5></div>
  <?
  $req_mod_counter = 0;
  foreach ($files as $file)
  {
    if ($file['is_required'] == true && $file['version_to'] != "removed" && ($file['pack_side'] == 1 || $file['pack_side'] == 2))
    {
      $req_mod_counter++;
      $query = "SELECT * FROM files WHERE parent_identifier = '".$file['update_id']."'";
      $result = mysqli_query($con, $query);
      $sub_files = "<div><dim>".$file['path']."</dim>".$file['filename']."</div>";
      $counter = 1;
      if ($result && mysqli_num_rows($result) > 0)
      {
        while ($row = mysqli_fetch_assoc($result))
        {
          $counter++;
          $sub_files .= "<div style='text-indent: 10px;'><dim>" . $row['path'] . "</dim>" . $row['filename'] . "</div>";
        }
      }
      echo insert($mod_entity, array(
        "name" => $file['mod_name'],
        "version" => $file['version_to'],
        "filename" => $file['filename'],
        "toggle" => "",
        "description" => ((isset($file['description']) && $file['description'] != "") ? "<dim> - " . $file['description'] . "</dim>" : ""),
        "more_info" => $sub_files,
        "file_count" => $counter,
        "s" => ($counter > 1) ? "s" : ""
      ));
    }
  }
  if ($req_mod_counter == 0)
    echo "<div>No mods to list</div>";
  ?>
  </div>
</div>
<? include_once("footer.php"); ?>
</body>
<script>
  var email = "<?=$email?>";
  var role = "<?=$session?>";
  var patron_title = "<?=$patron_title?>";
  var username = "";

  if (email != "No Email")
  {
    $.post("internal/user_get.php", {email: email})
      .done(function (payload)
      {
        payload = JSON.parse(payload);
        if (payload['result'] == 1 || payload['minecraft_name'] == "" || payload['minecraft_name'] == null || payload['minecraft_uuid'] == "" || payload['minecraft_uuid'] == null)
        {
          display_new_user_popup();
          overlay_on();
        }
        else if (payload['result'] == 0)
        {
          username = payload['minecraft_name'];
          document.getElementById("greeting_minecraft_name").innerHTML = username;

          if (payload['role'] == "patron" && payload['note'] != patron_title && patron_title != "")
          {
            console.log("Update user note to '" + patron_title + "'");
            $.post("internal/user_update_note.php", {user_id: payload['id'], note: patron_title});
          }
          else
            console.log("User does not have new title or title is empty ('" + patron_title + "')");
        }
      })
      .fail(function(payload)
      {
        console.error("Request failed (" + payload.status + ")");
      })
  }

  function toggle_icon(event)
  {
    var target = event.target;
    if (target.tagName != "SPAN")
      target = target.children[0];
    if (typeof target == "undefined")
      return;
    if (target.className != 'button_ok off')
      target.className = 'button_ok off';
    else
      target.className = "button_ok";
    event.stopPropagation();
  }

  function toggle_checkbox(event)
  {
    console.log(event);
    if (event.target.children[0].checked)
    {
      event.target.className = 'button_ok off';
      event.target.children[0].checked = false;
    }
    else
    {
      event.target.className = "button_ok";
      event.target.children[0].checked = true;
    }
  }

  function more_info_show(event)
  {
    event.target.onclick = more_info_hide;
    event.target.innerHTML = event.target.innerHTML.replace("Show", "Hide");
    event.target.parentElement.children[1].style.display = null;
  }

  function more_info_hide(event)
  {
    event.target.onclick = more_info_show;
    event.target.innerHTML = event.target.innerHTML.replace("Hide", "Show");
    event.target.parentElement.children[1].style.display = "none";
  }

  function request_generation()
  {
    overlay_spinner_on();
    var optional_mods = document.getElementsByClassName("optional_mods");
    var mods = [];
    for (let i = 0; i < optional_mods.length; i++)
    {
      console.log(optional_mods[i].value + ": " + optional_mods[i].checked);
      if (optional_mods[i].checked)
        mods.push(optional_mods[i].value);
    }
    var from_tag = document.getElementById("from_tag").value;

    var args = {
      opt_mods: mods
    };
    if (from_tag != "null")
      args['from'] = from_tag;

    console.log(mods);
    $.post("internal/generate_archive.php", args)
      .done(function(payload)
      {
        payload = JSON.parse(payload);
        console.info(payload);
        spinner_off();
        if (payload.result === 0)
          document.getElementById("spinner_text").innerHTML = "<a class='download_link' href='internal/get_file?id=" + payload['id'] + "&type=build'>Download</a><br/>Size: " + payload['size'] + "<br/>Mods: " + payload['count_mods'] + "<br/>Optional: " + payload['count_mods_opt'] + "<br/>Resource Packs: " + payload['count_resources'] + "<br/><span onclick='overlay_off();' class='dim pnt'>Close</span>";
        else
          document.getElementById("spinner_text").innerHTML = "<span class='error'>" + payload['msg'] + "</span><br/><span onclick='overlay_off();' class='dim pnt'>Close</span>";
      })
      .fail(function(payload)
      {
        console.error(payload);
        spinner_off();
      });
  }

  function display_new_user_popup()
  {
    document.getElementById("new_user_popup").style.display = null;
  }

  function hide_new_user_popup()
  {
    document.getElementById("new_user_popup").style.display = "none";
  }

  function register_username()
  {
    var input = document.getElementById("minecraft_name");
    if (typeof input === "undefined" || input === null)
      return;
    var minecraft_name = input.value;
    $.post("internal/user_new.php", {email: email, minecraft_name: minecraft_name, patron_title: patron_title})
      .done(function(payload)
      {
        payload = JSON.parse(payload);
        if (payload['result'] > 0)
        {
          let err = document.getElementById("new_user_error_output");
          err.className = "error";
          err.innerHTML = payload['msg'];
          err.style.display = null;
          console.error(payload['msg']);
          console.error(payload['detail']);
          console.error(payload['code']);
        }
        else if (payload['result'] === 0)
        {
          console.info("Success! ('" + payload['uuid'] + "')");
          document.getElementById("minecraft_name").innerHTML = minecraft_name;
          hide_new_user_popup();
          overlay_off();
          $.post("internal/update_whitelist.php", { soft_force: "true"});
        }
        else
          console.warn("Unknown error when registering user!");
      })
      .fail(function(payload)
      {
        let err = document.getElementById("new_user_error_output");
        err.className = "error";
        err.innerHTML = "API failed to respond. (" + payload.status + ")";
        err.style.display = null;
        console.error(payload);
      });
  }

  function patch_checkbox_change(event)
  {
    if (event.target.checked)
      show_patch_selector();
    else
      hide_patch_selector();
  }

  function show_patch_selector()
  {
    document.getElementById("pack_download_button").innerHTML = "Get Patch";
    document.getElementById("more_dl_options").style.display = "block";
  }

  function hide_patch_selector()
  {
    document.getElementById("pack_download_button").innerHTML = "Get Download";
    document.getElementById("more_dl_options").style.display = "none";
  }
</script>