<?
//Created 10/04/2017
require_once "inc_common_functions.php";
require_once "internal/inc_connect.php";
require_once "inc_functions.php";
require_once "constants.php";
require_once "auth.php";
require_once "internal/Patreon.php";
require_once "krumo/class.krumo.php";
require_once "Google/autoload.php";
require_once "Google/Client.php";
require_once "classes/Role.php";
require_once "classes/SimpleSetting.php";

use Patreon\API;
use Patreon\OAuth;

$errors = array(
  1 => "Login error",
  2 => "Insufficient pledge",
  3 => "You are banned.",
  4 => "Insufficient privileges",
  5 => "Unexpected Error",
  6 => "Internal Error",
);
$error = 0;
$error_detail = "";
$log = array();
$patreon_url = "https://www.patreon.com/oauth2/authorize?response_type=code&client_id=$patreon_client_id&redirect_uri=".urlencode($login_redirect_url);
$google_url = "?";
$email = "No Email";
$verified = false;
$role = new Role();
$simpleSettings = new SimpleSetting();

$patron_title = "";
$page_title = $simpleSettings->Load(SimpleSetting::$PAGE_TITLE)->Value();

list($session, $email) = get_login_session("public", false);
if ($session)
{
  $error = -1;
  $log[] = "Cookie login!";
  if (isset($_GET['redir']) && $_GET['redir'] == "admin")
    header("Location: admin/");
}
elseif (isset($_GET['code']) && isset($_GET['state'])) //// Patreon Login ////
{
  $oauth_client = new Patreon\OAuth($patreon_client_id, $patreon_client_secret);;

  $tokens = $oauth_client->get_tokens($_GET['code'], $login_redirect_url);
  $access_token = $tokens['access_token'];
  $refresh_token = $tokens['refresh_token'];

  $api_client = new Patreon\API($access_token);
  $patron_response = $api_client->fetch_user();
  if (!isset($patron_response['ErrorCodes']))
  {
    $patron = $patron_response['data'];
    $email = $patron['attributes']['email'];
    $included = $patron_response['included'];
    $pledge = null;
    if ($included != null)
    {
      foreach ($included as $obj)
      {
        if ($obj["type"] == "pledge" && $obj["relationships"]["creator"]["data"]["id"] == $patreon_creator_id)
        {
          $pledge = $obj;
          break;
        }
      }
    }

    if (!isset($access_rewards))
      $error = 5;
    elseif (isset($pledge) && array_key_exists($pledge['relationships']['reward']['data']['id'], $access_rewards))
    {
      $patron_title = $access_rewards[$pledge['relationships']['reward']['data']['id']];
      $log[] = "User has patron pledge level with access with title '" . $patron_title . "' and id '" . $pledge['relationships']['reward']['data']['id'] . "'";
      $error = -1;
    }
    else
    {
      $log[] = "User has insufficient pledge with id '" . $pledge['relationships']['reward']['data']['id'] . "'";
      $error = 2;
    }

    $query = "SELECT * FROM users WHERE email = '$email'";
    $result = mysqli_query($con, $query);
    if ($result && mysqli_num_rows($result) == 1)
    {
      $row = mysqli_fetch_assoc($result);
      if ($row['email'] == $email && $row['role'] != $role::$NONE)
      {
        $log[] = "Successful patreon login with role '" . $row['role'] . "'";
        $error = -1;
        init_login_session($email);
        header("Location: .");
      }
    }
    elseif (mysqli_num_rows($result) == 0)
    {
      $values = array(
        "email" => $email,
        "role" => "patron",
        "note" => $patron_title,
        "updated" => time()
      );
      $result = mysqli_query($con, build_query("users", $values, "insert"));
      if ($result)
        init_login_session($email);
      else
        $error = 6;
    }
    elseif (!$result)
      log_file(mysqli_error($con), "sql.log");
  }
  else
  {
    $error = 1;
    $error_detail = "Logging in with Patreon failed.";
    //$error_detail = $patron_response['errors'][0]['detail'];
  }
}
elseif (isset($_GET['code'])) //// Google Login ////
{
  $log[] = "Process google login";
  $client = new Google_Client();
  $client->setClientId($google_client_id);
  $client->setClientSecret($google_client_secret);
  $client->setRedirectUri($login_redirect_url . ((isset($_GET['redir']) && $_GET['redir'] == "admin") ? "?redir=admin" : ""));
  try
  {
    $payload = $client->authenticate($_GET['code']);
    if ($payload)
    {
      $payload = json_decode($payload);
      $result = $client->verifyIdToken($payload->id_token);
      $attributes = $result->getAttributes();
      $email = $attributes['payload']['email'];
      $verified = $attributes['payload']['email_verified'];
      $log[] = "Google payload email: $email is verified $verified";
      // If request specified a G Suite domain:
      //$domain = $payload['hd'];
    }
    else
    {
      $error = 1;
      $error_detail = "Logging in with Google failed.";
    }

    $log[] = "Get user";
    $query = "SELECT * FROM users WHERE email = '$email'";
    $result = mysqli_query($con, $query);
    if ($result && mysqli_num_rows($result) == 1)
    {
      $row = mysqli_fetch_assoc($result);
      $log[] = "Found user " . $row['minecraft_name'];
      if ($verified && $row['email'] == $email && ($row['role'] == $role::$ADMIN || $row['role'] == $role::$MODERATOR || $row['role'] == $role::$PATRON || $row['role'] == $role::$VIP))
      {
        $log[] = "User accepted";
        $error = -1;
        init_login_session($email);
        if (isset($_GET['redir']))
        {
          if ($_GET['redir'] == "admin")
            header("Location: admin/");
        }
        header("Location: .?error=$error");
      }
      elseif ($row['role'] == $role::$BANNED)
      {
        $log[] = "User is banned";
        $error = 3;
      }
      else
      {
        $log[] = "User has wrong role";
        $error = 4;
      }
    }
    elseif (!$result)
    {
      $error = 1;
      log_file(mysqli_error($con), "sql.log");
      $log[] = "An SQL Error occurred: " . mysqli_error($con);
    }
    elseif (mysqli_num_rows($result) == 0)
    {
      $log[] = "No rows returned";
      $error = 4;
    }
    else
    {
      $log[] = "Too many rows returned! PANIC!";
      $error = 4;
    }
  }
  catch (Exception $exception)
  {
    $error = 1;
    $error_detail = str_replace('"', "", str_replace("'", "", $exception->getMessage()));
  }
}

$google_client = new Google_Client();
$google_client->setClientId($google_client_id);
$google_client->setClientSecret($google_client_secret);
//$google_client->addScope(Google_Service_Plus::PLUS_LOGIN);
$google_client->addScope(Google_Service_Plus::USERINFO_EMAIL);
$google_client->setRedirectUri($login_redirect_url . ((isset($_GET['redir']) && $_GET['redir'] == "admin") ? "?redir=admin" : ""));
$google_url = $google_client->createAuthUrl();

//if (stristr($_SERVER['REQUEST_URI'], "ForeModpacker") !== false)
//  $error = -1;

?>
<?
if ($error >= 0)
{
  echo "
<!DOCTYPE html>
<html lang='en'>
<head>
  <meta charset='UTF-8'>
  <title>$page_title - ForeModpacker</title>
  <link rel='stylesheet' href='assets/bootstrap.min.css' />
  <script src='assets/jquery-1.12.0.min.js'></script>
  <script src='assets/bootstrap.min.js'></script>
  <script src='assets/cookie_functions.min.js'></script>
  <link rel='stylesheet' href='assets/styles.css' />
  <meta name='google-signin-client_id' content='<?=$google_client_id?>'>
</head>
<body>";
}

if (0 < $error || (isset($_GET['error']) && 0 < $_GET['error']))
{
  echo "<div id='error_output' class='error' style='text-align: center; display: " . ((0 < $error || (isset($_GET['error']) && 0 < $_GET['error'])) ? "null" : "none" ) . "'>";
  $show_error = $error;
  if (isset($_GET['error']))
    $show_error = $_GET['error'];
  echo "Access denied! ($errors[$show_error]) " . (($error_detail != "") ? "<span data-details='$error_detail' onclick='this.innerHTML = \"<br/>\" + this.getAttribute(\"data-details\")'>Details</span>" : "");
  echo "</div>";
}

if ($error != -1 && $error != 2 && $error != 4)
{
  if ($simpleSettings->Load(SimpleSetting::$USER_LOGIN)->TestEnabled())
  {
    ?>
<div style='position: absolute; top: 150px; left: 50%; width: 250px; margin-left: -125px; text-align: center;'>
  <div><a href='<?=$patreon_url?>'><button class='btn btn-primary' style='background-color: #e6461a; border: 0;'>Log In With Patreon</button></a></div>
  <div style="margin-top: 6px;"><a href='<?=$google_url?>'><button class='btn btn-primary'>Log In With Google</button></a></div>
  <div><label><input type='checkbox' onchange='keep_logged_in_change(event);' <?=((isset($_COOKIE['foremodpacker_keep_me_logged_in']) && $_COOKIE['foremodpacker_keep_me_logged_in'] == 'true') ? 'checked' : '')?> /> Keep Me Logged In</label></div>
  <? if ($simpleSettings->Load(SimpleSetting::$PUBLIC_MOD_LIST_ENABLED)->TestEnabled()) {
    ?> <div><a href="public_modlist">Public Mod List</a></div> <?
  } ?>
</div>
    <?
  }
  else
  {
    echo "
<div style='position: absolute; top: 50px; left: 50%; width: 250px; margin-left: -125px; text-align: center;'>
  <div><h4>SYSTEM OFFLINE</h4><br/>Please check back later.</div>
</div>";
  }
}

if ($error == 2 || $error == 4)
{
  $media_p = "";
  if (!isEmpty($settings[$simpleSettings::$MEDIA_STREAM_FOLLOWER]) && !isEmpty($settings[$simpleSettings::$MEDIA_STREAM_VIEWS]))
  {
    $media_p .= "<p style='font-size: 16pt;'>If you are a ";
    $media_p .= "streamer with at least <u>" . $settings[$simpleSettings::$MEDIA_STREAM_FOLLOWER] . "</u> followers and around <u>" . $settings[$simpleSettings::$MEDIA_STREAM_VIEWS] . "</u> views/stream";
  }
  if (!isEmpty($settings[$simpleSettings::$MEDIA_VIDEO_FOLLOWER]) && !isEmpty($settings[$simpleSettings::$MEDIA_VIDEO_VIEWS]))
  {
    if ($media_p == "")
      $media_p .= "<p style='font-size: 16pt;'>If you are a ";
    else
      $media_p .= "</p><p style='font-size: 16pt;'>Or a ";
    $media_p .= "Video creators with at least <u>" . $settings[$simpleSettings::$MEDIA_VIDEO_FOLLOWER] . "</u> subscribers and around <u>" . $settings[$simpleSettings::$MEDIA_VIDEO_VIEWS] . "</u> views/video";
  }
  if (!isEmpty($settings[$simpleSettings::$MEDIA_NOTE]))
  {
    $media_p .= "<p><b>" . $settings[$simpleSettings::$MEDIA_NOTE] . "</b></p>";
  }
  if ($media_p != "")
    $media_p .= "</p><p style='font-size: 16pt;'>You may apply for access to the server through official channels. Or you can become a Patron, or increase your pledge.</p>";
  echo "
<div style='position: absolute; top: 80px; left: 50%; width: 400px; margin-left: -200px; text-align: center;'>
  <div>
    <p style='font-size: 16pt;'>" . (($error == 2) ? "We're sorry! This feature is only available to sufficiently pledged Patrons" : "Sorry, you do not have access. Log in with Patreon, or become a Patron now for same-day access!") . "</p>
    ".$media_p."
    <p><a href='https://www.patreon.com/bePatron?u=89722' data-patreon-widget-type='become-patron-button'>Become a Patron!</a><script async src='https://cdn6.patreon.com/becomePatronButton.bundle.js'></script></p>
    <p><a href='?'>Back to login</a></p>
  </div>
</div>";
}
if ($error >= 0)
{
  echo "<div style='height: 800px;'></div>";
  include_once "footer.php";
  echo "
</body>
</html>";
}

if ($error == -1) require_once "generator.php";
?>
<script>
  console.log('Error: <?=$error?>');
  console.log('Email: <?=(isset($email)) ? $email : "No Email"?>');
  console.log('Role: <?=(isset($session)) ? $session : "No role"?>');
  console.log(JSON.parse('<?=str_replace("'", "\\'", json_encode($log))?>'));

  function keep_logged_in_change(event)
  {
    if (event.target.checked)
      setCookie("foremodpacker_keep_me_logged_in", "true", 999999999999999);
    else
      setCookie("foremodpacker_keep_me_logged_in", "false", 999999999999999);
  }
</script>
