<?
require_once "../inc_functions.php";
require_once "inc_connect.php";
require_once "krumo/class.krumo.php";
require_once "../auth.php";

function get_sub_files_query($update_id)
{
  return "SELECT * FROM files WHERE parent_identifier = '$update_id'";
}

function delete_sub_files($update_id)
{
  global $con, $ftp, $log, $ftp_server_root, $operations_count, $operations_success;
  $result = mysqli_query($con, get_sub_files_query($update_id));
  if ($result && mysqli_num_rows($result) > 0)
  {
    while ($sub_file = mysqli_fetch_assoc($result))
    {
      $del_result = ftp_delete($ftp, $ftp_server_root . $sub_file['path'] . $sub_file['filename']);
      $operations_success += $del_result;
      $operations_count++;
      $log[] = "Deleted sub file '" . $ftp_server_root . $sub_file['path'] . $sub_file['filename'] . "': " . (($del_result) ? "true" : "false");
    }
  }
  elseif (!$result)
    $log[] = "An SQL error occurred while getting sub-files for update id $update_id: " . mysqli_error($con);
  elseif (mysqli_num_rows($result) == 0)
    $log[] = "No sub-files for update id $update_id";
}

$result = mysqli_query($con,  "SELECT field_value FROM misc WHERE field_key = 'server_update_time'");

if ($result && mysqli_num_rows($result) == 1)
{
  $last_update = mysqli_fetch_array($result);
  $last_update = $last_update[0];
}
else
  $last_update = 0;

$result = mysqli_query($con, "SELECT * FROM files WHERE update_id IS NOT NULL AND update_id != '' AND release_tag IS NOT NULL AND release_tag != '' ORDER BY update_time DESC");

if ($result && mysqli_num_rows($result) > 0)
{
  $files = array();
  $files_to_upload = array();
  $log = array();

  while ($row = mysqli_fetch_assoc($result))
  {
    $mod_id = $row['mod_id'];
    if (!isset($files[$mod_id][0]))
      $files[$mod_id][0] = $row;
    elseif (!isset($files[$mod_id][1]))
      $files[$mod_id][1] = $row;
  }

  if (isset($ftp_use_ssl) && $ftp_use_ssl)
    $ftp = ftp_ssl_connect($ftp_host, $ftp_port);
  else
    $ftp = ftp_connect($ftp_host, $ftp_port);

  if ($ftp)
  {
    if (ftp_login($ftp, $ftp_username, $ftp_password))
    {
      $operations_count = 0;
      $operations_success = 0;
      $valid_updates_count = 0;
      foreach ($files as $file)
      {
        if ($file[0]['update_time'] > $last_update)
        {
          $valid_updates_count++;
          if (isset($file[1]))
          {
            if ($file[0]['version_to'] == "removed")
            {
              $del_result = ftp_delete($ftp, $ftp_server_root . $file[0]['path'] . $file[0]['filename']);
              $operations_success += $del_result;
              $operations_count++;
              $log[] = "Deleted '" . $ftp_server_root . $file[0]['path'] . $file[0]['filename'] . ": " . (($del_result) ? "true" : "false");

              delete_sub_files($file[1]['update_id']);
            }
            elseif ($file[0]['version_from'] != $file[0]['version_to'])
            {
              $del_result = ftp_delete($ftp, $ftp_server_root . $file[1]['path'] . $file[1]['filename']);
              $operations_success += $del_result;
              $operations_count++;
              $log[] = "Deleted '" . $ftp_server_root . $file[0]['path'] . $file[0]['filename'] . " before update: " . (($del_result) ? "true" : "false");
              $files_to_upload[] = $file[0];

              delete_sub_files($file[0]['update_id']);
            }
            elseif ($file[0]['version_from'] == $file[0]['version_to'])
            {
              delete_sub_files($file[0]['update_id']);

              $result = mysqli_query($con, "SELECT * FROM files WHERE parent_identifier = '" . $file[0]['update_id'] . "'");
              if ($result && mysqli_num_rows($result) > 0)
              {
                while ($sub_file = mysqli_fetch_assoc($result))
                  $files_to_upload[] = $sub_file;
              }
              elseif (!$result)
                $log[] = "An SQL error occurred while getting sub-files for entry " . $file[0]['id'] . ": " . mysqli_error($con);
              elseif (mysqli_num_rows($result) == 0)
                $log[] = "No sub-files for entry " . $file[0]['id'];
            }
          }
          else
          {
            if ($file[0]['version_from'] == "new")
            {
              $log[] = "Add new file for upload: " . $file[0]['filename'];
              $files_to_upload[] = $file[0];

              $result = mysqli_query($con, "SELECT * FROM files WHERE parent_identifier = '" . $file[0]['update_id'] . "'");
              if ($result && mysqli_num_rows($result) > 0)
              {
                while ($sub_file = mysqli_fetch_assoc($result))
                  $files_to_upload[] = $sub_file;
              }
              elseif (!$result)
                $log[] = "An SQL error occurred while getting sub-files for entry " . $file[0]['id'] . ": " . mysqli_error($con);
              elseif (mysqli_num_rows($result) == 0)
                $log[] = "No sub-files for entry " . $file[0]['id'];
            }
          }
        }
      }
      if ($valid_updates_count > 0)
        die(json_encode(array("result" => 0, "operations" => $operations_count, "successes" => $operations_success, "files_to_upload" => $files_to_upload, "log" => $log)));
      else
        die(json_encode(array("result" => 5, "msg" => "No tagged changes since last update")));
    }
    else
      die(json_encode(array("result" => 4, "msg" => "FTP login failed")));
  }
  else
    die(json_encode(array("result" => 3, "msg" => "Failed to connect to FTP server")));
}
elseif (!$result)
  die(json_encode(array("result" => 1, "msg" => "An SQL Error occurred", "details" => mysqli_error($con))));
else
  die(json_encode(array("result" => 2, "msg" => "No tagged files found")));