<?
require_once "inc_connect.php";
require_once "../inc_functions.php";
require_once "inc_common_functions.php";
require_once "krumo/class.krumo.php";
require_once "../classes/Side.php";

$side = new Side();

$query = "SELECT MAX(update_time) as update_time FROM files";
$result = mysqli_query($con, $query);
$result = mysqli_fetch_assoc($result);
$hash_str = $result['update_time'];
$hash = "";
$file_add_counter = 0;
$count_mods = 0;
$count_mods_opt = 0;
$count_resources = 0;
$log = array();

file_put_contents("generic.log", "");

$do_logging = false;
function operation_log($action, $result)
{
  global $log, $dev_mode, $do_logging;
  if ($dev_mode && $do_logging)
    $log[] = array("action" => $action, "result" => $result);
  else
    log_file($action . " => " . $result);
}

$errors = array(
  0 => "Success",
  1 => "An SQL error occurred when trying to get mod list",
  2 => "No mods found. If this problem persists please report this issue!",
  3 => "An SQL error occurred when trying to register the new build",
  4 => "No files were added to the archive",
  5 => " is not a valid tag",
  6 => "The 'from' tag needs to be before the 'to' tag",
  7 => "An SQL error occurred when trying to get a tag",
  8 => "Received empty tag for ",
);

$server_mode = false;
if (isset($_POST['server_mode']) && $_POST['server_mode'] == "true" || isset($_GET['server_mode']) && $_GET['server_mode'] == "true")
  $server_mode = true;
$dev_mode = false;
if (isset($_POST['dev_mode']) && $_POST['dev_mode'] == "true" || isset($_GET['dev_mode']) && $_GET['dev_mode'] == "true")
  $dev_mode = true;
$include_untagged = false;
if (isset($_POST['include_untagged']) && $_POST['include_untagged'] == "true")
  $include_untagged = true;
$is_patch = false;
$patch_from = null;
$patch_from_low = null;
$patch_to = null;
$patch_to_high = null;

if (isset($_POST['to']) || isset($_GET['to']))
{
  $patch_to = (isset($_POST['to']) ? $_POST['to'] : $_GET['to']);
}
if (isset($_POST['from']) || isset($_GET['from']))
{
  $is_patch = true;
  $patch_from = (isset($_POST['from']) ? $_POST['from'] : $_GET['from']);
}

$opt_mods = array();
if (isset($_POST['opt_mods']))
  $opt_mods = $_POST['opt_mods'];

operation_log("Running generator in patch mode", $is_patch);
if ($is_patch && isset($patch_from))
  operation_log("From tag", $patch_from);
if ($is_patch && isset($patch_to))
  operation_log("To tag", $patch_to);

if (isset($patch_to))
  $tag = $patch_to;
else
  $tag = get_latest_tag();

if (count($opt_mods) > 0)
  $hash_str .= implode("", $opt_mods).$tag;
else
  $hash_str .= $tag;
$hash_str .= (isset($_POST['from']) ? $_POST['from'] : "") . (isset($_GET['from']) ? $_GET['from'] : "");
$hash_str .= (isset($_POST['to']) ? $_POST['to'] : "") . (isset($_GET['to']) ? $_GET['to'] : "");
$hash = hash("SHA512", $hash_str);

if (!$dev_mode && !$include_untagged && !$server_mode)
{
  $query = "SELECT * FROM builds WHERE hash = '" . $hash . "'";
  $result = mysqli_query($con, $query);

  if ($result && mysqli_num_rows($result) > 0)
  {
    $row = mysqli_fetch_assoc($result);
    $file_size = filesize("../archives/".$row['system_file_name']);
    $values = array(
        "result" => 0,
        "msg" => "",
        "id" => $row['id'],
        "system_file_name" => $row['system_file_name'],
        "filename" => $row['filename'],
        "size" => humanFileSize($file_size),
        "size_raw" => $file_size,
        "generated" => $row['creation_time'],
        "count_mods" => $row['mod_count'],
        "count_mods_opt" => $row['mod_opt_count'],
        "count_resources" => $row['res_count'],
        "is_patch" => ($row['is_patch'] == 1),
        "pre_generated" => true
      );
    if ($row['is_patch'] == 1)
    {
      $values['patch_from'] = $row['patch_from'];
      $values['patch_to'] = $row['patch_to'];
    }
    if ($dev_mode)
      krumo($values, array("is_patch" => $is_patch, "patch_from" => $patch_from, "patch_to" => $patch_to));
    die(json_encode($values));
  }
}
else
  $hash = "dev";

$query_from_tag = "";
if (isset($patch_from))
{
  if ($patch_from == "")
    die(json_encode(array("result" => 8, "msg" => $errors[8] . "from")));
  $from_result = mysqli_query($con, "SELECT * FROM tags WHERE tag = '" . mysqli_escape($con, $patch_from) . "' LIMIT 1");

  if (!$result)
    die(json_encode(array("result" => 7, "msg" => $errors[7], "detail" => mysqli_error($con))));
  elseif (mysqli_num_rows($from_result) == 0)
    die(json_encode(array("result" => 5, "msg" => "\"" . $patch_from . "\"" . $errors[5])));

  $from_result = mysqli_fetch_assoc($from_result);
  $query_from_tag = "AND id >= '" . ($from_result['high_entry'] + 1) . "'";
  $patch_from_low = $from_result['low_entry'];
}

$query_to_tag = "";
if (isset($patch_to))
{
  if ($patch_to == "")
    die(json_encode(array("result" => 8, "msg" => $errors[8] . "to")));
  $to_result = mysqli_query($con, "SELECT * FROM tags WHERE tag = '" . mysqli_escape($con, $patch_to) . "' LIMIT 1");

  if (!$to_result)
    die(json_encode(array("result" => 7, "msg" => $errors[7], "detail" => mysqli_error($con))));
  elseif (mysqli_num_rows($to_result) == 0)
    die(json_encode(array("result" => 5, "msg" => "\"" . $patch_to . "\"" . $errors[5])));

  $to_result = mysqli_fetch_assoc($to_result);
  $query_to_tag = "AND id <= '" . $to_result['high_entry'] . "'";
  $patch_to_high = $to_result['high_entry'];
}

if ($is_patch)
  $order = "DESC";
else
  $order = "ASC";

$untagged = "AND release_tag IS NOT NULL AND release_tag != ''";
if ($include_untagged)
  $untagged = "";

$query = "SELECT * FROM files WHERE (file_type = 'mod' OR file_type = 'resource') $untagged $query_from_tag $query_to_tag ORDER BY update_time $order";
$result = mysqli_query($con, $query);
if ($dev_mode)
krumo($query);
operation_log("Query for getting mod entries", $query);

if ($result && mysqli_num_rows($result) > 0)
{
  $files = array();
  while ($row = mysqli_fetch_assoc($result))
  {
    if ($is_patch)
    {
      if (!isset($files[$row['mod_id']]) || !is_array($files[$row['mod_id']]))
        $files[$row['mod_id']] = array();
      array_push($files[$row['mod_id']], $row);
//      operation_log("Add " . $row['mod_id'] . " (" . $row['id'] . ") to file array", "1");
    }
    else
    {
      $files[$row['mod_id']][0] = $row;
    }
  }

  if ($is_patch)
  {
    foreach ($files as $key => $file)
    {
      if ($file[0]['version_to'] != "removed")
      {
        $query = "SELECT * FROM files WHERE mod_id = '" . $file[0]['mod_id'] . "' AND id < '" . $file[0]['id'] . "' ORDER BY id DESC";
        $result = mysqli_query($con, $query);
        operation_log("Get past files for '" . $file[0]['mod_id'] . "' (" . $file[0]['id'] . "): " . $query, mysqli_num_rows($result));
        if ($result)
        {
          while ($row = mysqli_fetch_assoc($result))
            array_push($files[$key], $row);
        }
      }
    }
  }

  $zip = new ZipArchive();
  $date = date("Y-m-d");
  if (!$server_mode)
  {
    $zip_system_name = "modpack-$date-$tag-$hash.zip";
    if ($dev_mode)
    {
      $zip_name = "modpack-$date-dev-client.zip";
      $zip_system_name = "modpack-dev-client.zip";
    }
    elseif ($include_untagged)
    {
      $zip_name = "modpack-$date-test-client.zip";
      $zip_system_name = "modpack-test-client.zip";
    }
    elseif (!$is_patch)
      $zip_name = "modpack-$date-$tag.zip";
    else
    {
      $zip_name = "modpack-$date-$tag-patch";
      if (isset($patch_to))
        $zip_name = "modpack-$date-$patch_to-patch";
      if (isset($patch_from))
        $zip_name .= "-from-$patch_from";
      $zip_name .= ".zip";
    }
  }
  else
  {
    $zip_system_name = "server_pack.zip";
    $zip_name = "server_pack.zip";
  }

  if (file_exists("../archives/$zip_system_name"))
    unlink("../archives/$zip_system_name");
  operation_log("open '" . $zip_system_name . "'", $zip->open("../archives/$zip_system_name", ZipArchive::CREATE));

  $zip->addFromString("pack.version", $tag);

  if ($dev_mode)
    krumo($files);

  foreach ($files as $mod)
  {
    for ($index = 0; $index < min((($is_patch) ? count($mod) : 1), count($mod)); $index++)
    {
      $include_mod = false;
      if ($mod[$index]['version_to'] != "removed" && $index == 0)
      {
        if ($dev_mode && ($mod[$index]['pack_side'] == $side::$BOTH || $mod[$index]['pack_side'] == $side::$CLIENT))
          $include_mod = true;
        if ($server_mode && ($mod[$index]['pack_side'] == $side::$SERVER || $mod[$index]['pack_side'] == 1) && $mod[$index]['file_type'] != "resouce")
          $include_mod = true;
        elseif (!$server_mode && ($mod[$index]['pack_side'] == $side::$BOTH || $mod[$index]['pack_side'] == 2) && $mod[$index]['is_required'] || in_array($mod[$index]['mod_id'], $opt_mods))
          $include_mod = true;

        operation_log("Include " . $mod[$index]['mod_name'] . ": " . $include_mod, "Included");
        if ($include_mod)
        {
          $file_path = "../files/" . $mod[$index]['system_file_name'];
          if (file_exists($file_path))
          {
            $file_add_counter++;
            if ($mod[$index]['file_type'] == "mod" && $mod[$index]['is_required'])
              $count_mods++;
            elseif ($mod[$index]['file_type'] == "mod")
              $count_mods_opt++;
            elseif ($mod[$index]['file_type'] == "resource")
              $count_resources++;
            operation_log("Add file '" . $file_path . "' as '" . $mod[$index]['path'] . $mod[$index]['filename'] . "'", $zip->addFile($file_path, $mod[$index]['path'] . $mod[$index]['filename']));
          }
          else
            operation_log("Add file '" . $file_path . "'", "File does not exist");
          $sub_query = "SELECT * FROM files WHERE parent_identifier = '".$mod[$index]['update_id']."'";
          $sub_result = mysqli_query($con, $sub_query);
          if ($sub_result && mysqli_num_rows($sub_result) > 0)
          {
            while ($sub_file = mysqli_fetch_assoc($sub_result))
            {
              $file_path = "../files/" . $sub_file['system_file_name'];
              if (file_exists($file_path))
              {
                $file_add_counter++;
                if ($sub_file['version_to'] != "removed")
                {
                  operation_log(
                    "Add sub-file '" . $file_path . "' as '" . $sub_file['path'] . $sub_file['filename'] . "' (" . $sub_file['id'] . ") (" . filesize($file_path) . ") entry '" . $sub_file['id'] . "'",
                    $zip->addFile($file_path, $sub_file['path'] . $sub_file['filename']));
                }
                else
                {
                  operation_log(
                    "Add dummy file for " . $sub_file['version_to'] . " sub-file '" . $sub_file['filename'] . "' (" . $sub_file['id'] . ")",
                    $zip->addFromString($sub_file['path'] . $sub_file['filename'], ""));
                }
              }
              else
                operation_log("Skip file '" . $file_path . "' because it doesn't exist", "It doesn't");
            }
          }
          else
            operation_log("No sub-files to parse for","'" . $mod[$index]['mod_id'] . "' (" . $mod[$index]['id'] . ") (" . $mod[$index]['update_id'] . ")");
        }
        else
          operation_log("Skipping file index because include is false", "");
      }
      elseif ($is_patch) // If file was removed, or it's not the first file, and we're patching, add null files for main and sub-files
      {
        $local_name = $mod[$index]['path'] . $mod[$index]['filename'];
        if (!$zip->locateName($local_name))
        {
          $file_add_counter++;
          operation_log("Add dummy file for main-file '" . $mod[$index]['filename'] . "' (" . $mod[$index]['id'] . ")", $zip->addFromString($local_name, ""));
        }
        else
          operation_log("Add dummy file for main-file '" . $mod[$index]['filename'] . "' (" . $mod[$index]['id'] . ")", "No dummy file added because file already exists");
        $sub_result = mysqli_query($con, "SELECT * FROM files WHERE parent_identifier = '" . $mod[$index]['update_id'] . "'");
        operation_log("Get sub-files for '" . $mod[$index]['mod_id'] . "' (" . $mod[$index]['id'] . ")", $sub_result == true);
        if ($sub_result)
        {
          while ($sub_file = mysqli_fetch_assoc($sub_result))
          {
            $sub_local_name = $sub_file['path'] . $sub_file['filename'];
            if (!$zip->locateName($sub_local_name))
            {
              $file_add_counter++;
              operation_log("Add dummy file for sub-file '" . $sub_file['filename'] . "' (" . $sub_file['id'] . ")", $zip->addFromString($sub_local_name, ""));
            }
            else
              operation_log("Add dummy file for sub-file '" . $sub_file['filename'] . "' (" . $sub_file['id'] . ")", "No file added because sub-file already exists");
          }
        }
      }
      else
        operation_log("File '" . $mod[$index]['filename'] . "' was marked as removed, but we're not patching", true);
      operation_log($mod[$index]['id'] . " < " . $patch_from_low, ($mod[$index]['id'] < $patch_from_low) ? "true" : "false");
      if (isset($patch_from_low) && $mod[$index]['id'] < $patch_from_low)
        break;
      operation_log("===================================", "--------------------");
    }
  }

  operation_log("close", $zip->close());

  $values = array(
    "hash" => $hash,
    "system_file_name" => $zip_system_name,
    "filename" => $zip_name,
    "creation_time" => time(),
    "last_download" => 0,
    "mod_count" => $count_mods,
    "mod_opt_count" => $count_mods_opt,
    "res_count" => $count_resources,
    "is_patch" => $is_patch,
    "patch_from" => (isset($patch_from) ? $patch_from : null),
    "patch_to" => (isset($patch_to) ? $patch_to : ($is_patch) ? $tag : null)
  );
  if ($dev_mode)
    krumo($values);

  log_file(json_encode($log), "../zip.log");

  operation_log("File add counter", $file_add_counter);

  if (!$dev_mode && !$include_untagged && $file_add_counter > 0 && !$server_mode)
  {
    $result = mysqli_query($con, build_query("builds", $values));
    if ($result)
    {
      $id = mysqli_insert_id($con);
      $file_size = filesize("../archives/".$zip_system_name);
      $values = array(
        "result" => 0,
        "id" => $id,
        "system_file_name" => $zip_system_name,
        "filename" => $zip_name,
        "size" => humanFileSize($file_size),
        "size_raw" => $file_size,
        "generated" => $values['creation_time'],
        "count_mods" => $count_mods,
        "count_mods_opt" => $count_mods_opt,
        "count_resources" => $count_resources,
        "log" => $log,
        "is_patch" => $is_patch,
        "pre_generated" => false
      );
      if ($dev_mode)
        krumo($values, $log);
      if (isset($patch_from))
        $values['patch_from'] = $patch_from;
      if (isset($patch_to))
        $values['patch_to'] = $patch_to;
      die(json_encode($values));
    }
    else
    {
      log_file(mysqli_error($con), "../sql.log");
      die(json_encode(array("result" => 3, "msg" => $errors[3], "log" => $log)));
    }
  }
  elseif ($dev_mode || $include_untagged)
  {
    foreach ($log as $entry)
      echo "<div>" . $entry['action'] . " => " . $entry['result'] . "</div>";
    die(json_encode(array("result" => 0, "msg" => "", "id" => "dev", "count_mods" => $count_mods, "count_mods_opt" => $count_mods_opt, "count_resources" => $count_resources, "log" => $log)));
  }
  elseif (!$server_mode)
    die(json_encode(array("result" => 4, "msg" => $errors[4], "log" => $log)));
  else
    die(json_encode(array("result" => 0, "msg" => "", "filename" => $zip_name, "generated" => $values['creation_time'], "count_mods" => $count_mods, "count_mods_opt" => $count_mods_opt, "count_resources" => $count_resources, "log" => $log)));
}
elseif (!$result)
{
  log_file(mysqli_error($con), "../sql.log");
  log_file("File query: <" . $query . ">", "../sql.log");
  die(json_encode(array("result" => 1, "msg" => $errors[1])));
}
else
  die(json_encode(array("result" => 2, "msg" => $errors[2])));
