<?

/**
 * Class MenuButton
 * Menu system version 0.1
 * @property String $title
 * @property String $hover_title
 * @property String $function A Javascript function
 * @property String $level
 */
class MenuButton
{
  public $title;
  public $hover_title;
  public $function;
  public $level;

  /**
   * MenuButton constructor.
   * @param String $title
   * @param String $function A Javascript function
   * @param String $hover_title
   * @param String $level
   */
  public function __construct($title, $function, $hover_title = null, $level = null)
  {
    $this->title = $title;
    $this->function = $function;
    $this->hover_title = $hover_title;
    $this->level = $level;
  }

  /**
   * @return String
   */
  public function GetTitle()
  {
    return $this->title;
  }

  /**
   * @return String
   */
  public function GetFunction()
  {
    return $this->function;
  }

  /**
   * @return String
   */
  public function GetHoverTitle()
  {
    return $this->hover_title;
  }

  /**
   * @return String
   */
  public function GetLevel()
  {
    return $this->level;
  }

  /**
   * @param string $item_class
   * @param int $zIndex
   * @return string
   */
  public function BuildItem($item_class = "", $zIndex)
  {
    global $session;
    if (isset($this->level) && (!isset($session) || !role_has_access($session, $this->level)))
      return "";
    $label = $this->GetTitle();
    $onclick = $this->GetFunction();
    if (isset($zIndex))
      $zIndex = " style='z-index: $zIndex;'";
    return "<div class=\"$item_class\" onclick=\"$onclick\" $zIndex>$label</div>";
  }
}