<?

/**
 * Class MenuSubmenu
 * Menu system version 0.1
 * @property string $title
 * @property MenuLink[]|MenuButton[] $items
 * @property string $hover_title
 * @property string $level
 * @deprecated Use Menu class instead!
 */
class MenuSubmenu
{
  public $title;
  public $items;
  public $hover_title;
  public $level;

  public function __construct($title, $hover_title = null, $level = null)
  {
    $this->title = $title;
    $this->hover_title = $hover_title;
    $this->level = $level;
    $this->items = array();
  }

  /**
   * @return string
   */
  public function GetTitle()
  {
    return $this->title;
  }

  /**
   * @return string
   */
  public function GetHoverTitle()
  {
    return $this->hover_title;
  }

  /**
   * @return string
   */
  public function GetLevel()
  {
    return $this->level;
  }

  /**
   * @return MenuButton[]|MenuLink[]|MenuSpacer[]
   */
  public function GetItems()
  {
    return $this->items;
  }

  /**
   * @param MenuLink $link
   */
  public function AddLink($link)
  {
    if (isset($link))
      array_push($this->items, $link);
  }

  /**
   * @param MenuButton $button
   */
  public function AddButton($button)
  {
    if (isset($button))
      array_push($this->items, $button);
  }

  /**
   * @param string $title
   */
  public function AddSpacer($title = "")
  {
    require_once __DIR__ . "/MenuSpacer.php";
    array_push($this->items, new MenuSpacer($title));
  }
}