<?
//Created 11/12/2017
require_once "classes/SimpleSetting.php";
require_once "classes/Side.php";
require_once "internal/inc_connect.php";
require_once "inc_functions.php";
require_once "inc_common_functions.php";
require_once "krumo/class.krumo.php";

$settings = array();
handle_setting(SimpleSetting::$PAGE_TITLE, true);
handle_setting(SimpleSetting::$FORGE_VERSION, true);
handle_setting(SimpleSetting::$PUBLIC_MOD_LIST_ENABLED, true);

if (!test_setting(SimpleSetting::$PUBLIC_MOD_LIST_ENABLED, "enabled"))
  header("Location: index");

$side_server = Side::$SERVER;

$files = array();
$query = "SELECT * FROM files WHERE release_tag IS NOT NULL && release_tag != '' ORDER BY update_time ASC";
$result = mysqli_query($con, $query);

while ($row = mysqli_fetch_assoc($result))
{
  $files[$row['mod_id']] = $row;
}
$files = array_order_by($files, "mod_name", SORT_ASC);

function print_row($file, $is_required)
{
  global $count;
  if ($file['file_type'] != "mod")
    return;
  if ($file['version_to'] == "removed")
    return;
  if ($file['is_required'] != $is_required)
    return;

  $count++;
  echo "" .
  "<TR>" .
    "<TD>" . $file['mod_name'] . "</TD>" .
    "<TD>" . $file['version_to'] . "</TD>" .
    "<TD style='white-space: nowrap;'>" . ($file['pack_side'] == Side::$CLIENT ? " [Client Only]" : "") . "</TD>" .
    "<TD>" . $file['description'] . "</TD>" .
  "</TR>";
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
  <title>ForeModpacker - <?=$settings['page_title']?></title>
  <link rel='stylesheet' href='assets/bootstrap.min.css' />
  <script src='assets/bootstrap.min.js'></script>
  <script src='assets/cookie_functions.min.js'></script>
  <link rel='stylesheet' href='assets/styles.css' />
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <style>
    table {
      width: 100%;
    }

    TR {
      transition-property : background-color;
      transition-duration : .5s;
    }

    TR:nth-child(2n) {
      background-color : #2f2f2f;
    }

    TR:hover {
      background-color : #1A1A1A;
    }

    up {
      text-transform: uppercase;
    }
  </style>
</head>
<body>
<div>
  <?
  $menu = get_default_menu();
  $menu->AddLink(new MenuLink("Back", "."), true);
  echo $menu->BuildMenu();
  ?>
</div>
<div class="container">
  <div class="major-header"><?=$settings['page_title']?></div>
  <div class="header">Forge Version: <span style="color: #41AF83"><?=$settings[SimpleSetting::$FORGE_VERSION]?></span></div>
  <div class="header">Modpack Version (tag): <?=get_latest_tag(false, true, false)?></div>
  <div class="header" id="required"><up>Required Mods</up> <span><a href="#optional">Jump to optional</a></span></div>
  <div>
    <table>
<?
$count = 0;
foreach ($files as $file)
  print_row($file, true);
if ($count == 0)
  echo "<TR><TD>No Required Mods Found</TD></TR>";
?>
    </table>
  </div>
  <div>
    <div class="header" id="optional"><up>Optional Mods</up> <span><a href="#required">Jump to required</a></span></div>
    <table>
<?
$count = 0;
foreach ($files as $file)
  print_row($file, false);
if ($count == 0)
  echo "<TR><TD>No Optional Mods Found</TD></TR>";
?>
    </table>
  </div>
</div>
</body>
</html>