<!DOCTYPE html>
<?
require_once "krumo/class.krumo.php";
krumo($_POST);
$name = "MinePickpacker";
$step = "1";
if (isset($_POST['step']))
  $step = $_POST['step'];

$steps = array(
  "1" => array("name" => "Introduction"),
  "2" => array("name" => "MySQL Setup"),
  "3" => array("name" => "Master Account Setup"),
  "4" => array("name" => "Configuration"),
  "5" => array("name" => "Result")
);

$title = "Install $name - Step " . $step;

$test_connection = null;
$test_connection_error = "";
$db_host = "localhost";
$db_user = "";
$db_name = "";
$db_port = "3306";
$db_pass = "";
$db_prefix = "mpp_";
function test_connection()
{
  global $test_connection, $test_connection_error, $db_host, $db_user, $db_name, $db_port, $db_pass, $db_prefix;
  if (isset($_POST['debug_test_connection']) && $_POST['debug_test_connection'] == "1")
  {
    $test_connection = true;
    return;
  }
  if (isset($_POST['test_connection']) && $_POST['test_connection'] == "1")
  {
    $db_host = $_POST['db_host'];
    $db_user = $_POST['db_user'];
    $db_name = $_POST['db_name'];
    $db_port = $_POST['db_port'];
    $db_pass = $_POST['db_pass'];
    $db_prefix = $_POST['db_prefix'];
    if ($db_host == "")
    {
      $test_connection = false;
      $test_connection_error = "No host specified";
      return;
    }
    if ($db_user == "")
    {
      $test_connection = false;
      $test_connection_error = "No user specified";
      return;
    }
    if ($db_name == "")
    {
      $test_connection = false;
      $test_connection_error = "No database name specified";
      return;
    }
    if ($db_port == "")
    {
      $test_connection = false;
      $test_connection_error = "No port specified";
    }
    $con = mysqli_connect($db_host, $db_user, $db_pass, $db_name, $db_port);
    if ($con)
      $test_connection = true;
    else
    {
      $test_connection = false;
      $test_connection_error = mysqli_connect_error();
    }
  }
}

test_connection();
?>
<html lang='en'>
<head>
  <meta charset='UTF-8'>
  <title>Step <?= $step ?> - Install</title>
  <link rel='stylesheet' href='../../assets/bootstrap.min.css' />
  <script src='../../assets/bootstrap.min.js'></script>
  <script src='../../assets/cookie_functions.min.js'></script>
  <link rel='stylesheet' href='../../assets/styles.css' />
  <script src='../../assets/jquery-1.12.0.min.js'></script>
  <style>
    .hidden
    {
      display: none;
      color: #8e8e8e;
    }

    .expand
    {
      cursor: pointer;
    }

    .expand:hover
    {
      color: lightblue;
    }

    label
    {
      padding-top: 4px;
    }

    li.current_step
    {
      font-weight: bold;
    }
  </style>
</head>
<body>
<div class="container" style="background-color: rgba(0,0,0,.15);">
  <div class="row">
    <div class="col-md-3">
      <ol>
      <?
      foreach ($steps as $i => $st)
        echo "<li" . ($i == $step ? " class='current_step'" : "") . ">" . $st['name'] . "</li>";
      ?>
      </ol>
    </div>
    <div class="col-md-9">
<?
if (file_exists("../../config.json") && file_get_contents("../../config.json") != "")
{
  ?>
  <div class="container">
    <div class="row">
      <div class="col-md-12 error">
        A non-empty config.json was found! This indicates the system has already been installed! If not please remove or re-name the config.json file before trying again!
      </div>
    </div>
  </div>
  <?
}
elseif ($step == "1")
{
  ?>
  <div class="container">
    <div class="row">
      <div class="col-md-12">
        <h2><?= $title ?></h2>
      </div>
    </div>
    <div class="row">
      <div class="col-md-12">
        <p>Hello!</p>
        <p>If you're reading this you're about to install <span class="yay">MinePickpacker</span>!</p>
        <p><span class="yay">MinePickpacker</span> is a system that allows you to build, host and manage a platform and
          launcher independent Minecraft modpack!</p>
        <p>I'll list the major features of the system below, and you can click on them to display a brief description of
          each if you like.</p>
        <ul>
          <li><span class="expand" data-id="platform">Platform Independence</span></li>
          <div id="platform" class="hidden">
            Being hosted on the web, users are never limited by what kind of system they are using!
          </div>
          <li><span class="expand" data-id="launcher">Launcher Independence</span></li>
          <div id="launcher" class="hidden">
            Not being tied to a specific launcher means users can use whatever they want.<br/>
            Regardless whether they use the vanilla launcher, MultiMC or anything else, they'll be able to use the modpack!
          </div>
          <li><span class="expand" data-id="management">Easy management</span></li>
          <div id="management" class="hidden">
            The modpack is managed through a straightforward interface and requires no editing of any xml or json files!<br/>
            All you have to do is upload files and fill in a few fields!
          </div>
          <li><span class="expand" data-id="downloads">Easy customizable downloads</span></li>
          <div id="downloads" class="hidden">
            The user can easily download the latest version of the modpack, opting in or out of any optional files as
            they like!<br/>
            The pack files are generated on the fly but only if needed depending on optional mods and pack updates.
          </div>
          <li><span class="expand" data-id="patches">Patch downloads</span></li>
          <div id="patches" class="hidden">
            Users can download a "patch" containing only the files needed to go from one version of the pack to another!<br/>
            This makes for more efficient downloads! The system also handles replacing old and unused files!
          </div>
          <li><span class="expand" data-id="login">Patreon or Google login</span></li>
          <div id="login" class="hidden">
            OAuth login using Google or Patreon provides secure login for admin access and/or pack access!<br/>
            Support for other OAuth compatible sites can be added if needed!
          </div>
          <li><span class="expand" data-id="tiers">Require Patreon tiers to access</span></li>
          <div id="tiers" class="hidden">
            Require users to be a patron in certain tiers to be allowed to download the pack, or leave it open for
            anyone!
          </div>
          <li><span class="expand" data-id="info">Info pages</span></li>
          <div id="info" class="hidden">
            Put up info pages in a wiki-like style where you can provide info about the pack or server to users!
          </div>
        </ul>
        <p>During the installation you will be asked to enter details such as database login, owner account details, API
          keys, and so on!</p>
        <p>During the installation a <code>config.json</code> file will be created in the root of the site, containing database connection details, tables will be set up in the database and an owner account will be set up!</p>
        <p><span class="error">Please read the instructions on each page carefully!</span></p>
        <p>When you're ready to proceed hit next!</p>
      </div>
    </div>
    <div class="row" style="margin-bottom: 12px;">
      <div class="col-md-11"></div>
      <div class="col-md-1">
        <form action="." method="post">
          <button name="step" value="2" class="btn btn-primary">Next</button>
        </form>
      </div>
    </div>
  </div>
  <?
}
elseif ($step == "2")
{
  ?>
  <form action="." method="post">
    <?
    foreach ($_POST as $key => $value)
      echo "<input type='hidden' name='$key' value='$value' />";
    ?>
    <div class="container">
      <div class="row">
        <div class="col-md-12">
          <h2><?= $title ?></h2>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          <p class="error">Make sure to enter the below details carefully! You must successfully connect to the database to proceed!</p>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          <p>These details will be saved in the <code>config.json</code> file after the final step!</p>
          <p>It's generally recommended to create specific user accounts for each database, since the details are stored in plain text. You should never use a root account in cases like this, since if the file somehow is leaked someone could get root access to your database server.</p>
        </div>
      </div>
      <div class="row">
        <div class="col-md-4">
          <input type="text" class="form-control" name="db_host" id="db_host" placeholder="Database Host" value="<?= $db_host ?>"/>
        </div>
        <div class="col-md-8"><label for="db_host">Database Host</label></div>
      </div>
      <div class="row">
        <div class="col-md-4">
          <input type="text" class="form-control" name="db_port" id="db_port" placeholder="Database Port" value="<?= $db_port ?>"/>
        </div>
        <div class="col-md-8"><label for="db_port">Database Port</label></div>
      </div>
      <div class="row">
        <div class="col-md-4">
          <input type="text" class="form-control" name="db_name" id="db_name" placeholder="Database Name" value="<?= $db_name ?>"/></div>
        <div class="col-md-8"><label for="db_name">Database Name<dim> - If empty uses username</dim></label></div>
      </div>
      <div class="row">
        <div class="col-md-4">
          <input type="text" class="form-control" name="db_user" id="db_user" placeholder="Database Username" value="<?= $db_user ?>"/></div>
        <div class="col-md-8"><label for="db_user">Database Username</label></div>
      </div>
      <div class="row">
        <div class="col-md-4">
          <input type="password" class="form-control" name="db_pass" id="db_pass" placeholder="Database Password" value="<?= $db_pass ?>"/>
        </div>
        <div class="col-md-8"><label for="db_pass">Database Password</label></div>
      </div>
      <div class="row">
        <div class="col-md-4">
          <input type="text" class="form-control" name="db_prefix" id="db_prefix" placeholder="Table Prefix" value="<?= $db_prefix ?>"/>
        </div>
        <div class="col-md-8"><label for="db_prefix">Table Prefix<dim> - Useful if multiple instances share the same database</dim></label>
        </div>
      </div>
      <? if (isset($test_connection)) { ?>
        <div class="row">
          <div class="col-md-12" style="margin-top: 12px;">
            <?= ($test_connection ? "<span class='yay'>Connection Successful</span>" : "<span class='error'>Connection failed</span> - <dim>" . $test_connection_error . "</dim>") ?>
          </div>
        </div>
      <? } ?>
      <div class="row" style="margin-top: 12px;">
        <div class="col">
          <a href=".">
            <div class="btn btn-danger">Back</div>
          </a>
        </div>
        <div class="col" style="text-align: center;">
          <button name="test_connection" value="1" class="btn btn-outline-warning">Test Connection</button>
        </div>
        <div class="col" style="text-align: center;">
          <button name="debug_test_connection" value="1" class="btn btn-outline-danger">Debug Bypass Test</button>
        </div>
        <div class="col" style="text-align: right;">
          <button name="step" value="3" class="btn btn-primary" <?= (!$test_connection ? "disabled" : "") ?> >Next</button>
        </div>
      </div>
    </div>
  </form>
  <?
}
elseif ($step == "3")
{
  $config_json = array(
    "database" => array(
      "host" => $_POST['db_host'],
      "port" => $_POST['db_port'],
      "name" => $_POST['db_name'],
      "user" => $_POST['db_name'],
      "pass" => $_POST['db_pass'],
      "table_prefix" => $_POST['db_prefix'])
  );
  ?>
  <div class="container">
    <div class="row">
      <div class="col-md-12">
        <h2><?= $title ?></h2>
      </div>
    </div>
    <div class="row">
      <div class="col" style="text-align: right;">
        <button class="btn btn-primary">Next</button>
      </div>
    </div>
  </div>
  <?
}
else
{
  ?>
  <div>Unhandled Step <?= $step ?></div>
  <?
}
?>
    </div>
  </div>
</div>
<script>
  $("span").each(function(i, element)
  {
    if (element.classList.contains("expand"))
      element.onclick = toggle_description;
  });

  function toggle_description(event)
  {
    $('#' + event.target.getAttribute("data-id")).toggle("fast");
  }
</script>
</body>
